/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file. 
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and 
** destructor.
*****************************************************************************/
#include<qmessagebox.h>
#include <qprocess.h>  
#include <qdir.h>
#include <MainForm.h> 
#include <qfile.h>  
#include <qstringlist.h> 
#include <qstring.h> 
#include <qlistview.h>  
#include <string.h>
#include <stdio.h> 
#include <qlistbox.h> 
#include <qlineedit.h>
#define kor(str) QString::fromLocal8Bit(str)
void G_Report_Form::readFromStdout()
{
 Text_Report->insert(proc->readStdout());
}


void G_Report_Form::ProcessEnd()
{
    system("rm "+mainform->Path +"*.o"); 
    QFile file(mainform->Path + "G_Report.txt");
    QString ddd;

    int temp_line, temp_col;
    int real_line, real_col;
    if(!file.open(IO_WriteOnly))
    {
               	QMessageBox::warning(this, "file Save Error\n\n", "Can NOT write G_Report");
     }
    else
    {
	QTextStream stream(&file);
	stream << Text_Report->text() ;
	file.close();
    }
 
    for( int i = 0 ; i < mainform->Text_index ; i++)
    {
	    mainform->pText[i]->moveCursor(QTextEdit::MoveHome, false);
	    while(1)
	    {
		if( mainform->pText[i]->find(mainform->E_enterCode->text(), true, false, true, 0, 0) == false )
		    break;
		    mainform->pText[i]->del();
	    }
   }

    mainform->fileSave();
    Print_Error_Code();    
    this->close();
    
    
}



bool G_Report_Form::Fliter_fflush( int line )
{
        char test[30];
    char test1[30];
    int temp_line;
    QStringList::ConstIterator it = fflush.constBegin();
    while(it != fflush.constEnd())
    {
	memset(&test, 0, sizeof(test));
	memset(&test1, 0, sizeof(test1));
	strcpy(test, *(it));
	for( int i = 0 ; i < strlen(test); i++)
	{	
	    if(test[i] == '/')
	    {
		strncpy(test1, test, i);
		temp_line =  atoi(test1);
		if( line == temp_line )
		    return true;
		else
		    break;
	    }
	}
	it++;
    }
    return false;
}

void G_Report_Form::init()
{
    ErrorNum = 0;
    WarningNum = 0;
}


void G_Report_Form::SetMainFormPointer( MainForm * fp )
{
    mainform = fp;
} 


void G_Report_Form::Make()
{
    mainform->compile_prograss->show();
    QString exe_file;
    char sentence[100];
    QDir dir;
    dir.setPath(mainform->Path);
    int mode = 0x04;//About stderr(ERROR);
    proc = new QProcess(this);
    proc->setCommunication(mode);
    proc->setWorkingDirectory(dir);
    proc->addArgument("make");
   connect( proc, SIGNAL(readyReadStdout()), this , SLOT(readFromStdout()) );
   connect(proc, SIGNAL(readyReadStderr ()), this, SLOT(readFromStderr()));
   connect( proc, SIGNAL(processExited()), this, SLOT(ProcessEnd()));
   proc->start();
   mainform->exe_proc = proc;
}


void G_Report_Form::OpenReport()
{
    QFile file(mainform->Path + "G_Report.txt");
    if(!file.open(IO_ReadOnly))
    {
               	QMessageBox::warning(this, "file Save Error\n\n", "Can NOT read G_Repor");
     }
    else
    {
	QTextStream stream(&file);
	Text_Report->setText(stream.read());
	file.close();
    }
}




void G_Report_Form::readFromStderr()
{
  QString str = proc->readStderr();  
  mainform->compile_prograss->insert(kor(str));
  Text_Report->insert(kor(str));  
}


void G_Report_Form::Print_Error_Code()
{
    typedef struct Error
    {
	char file_name[100];
	char file_line[10];
	char file_col[10];
	char file_kind[15];
	char message[800];	
    }error_List;
    QString Line;
    QString col;
    QString kind;
    QString message;
    
    error_List error;
    QString line;
    QString result;
    char temp[1000];
    int num = 0;
    int index = 0;    
    QListViewItem *item;
    QFile file(mainform->Path + "G_Report.txt");
    memset(&error, 0, sizeof(Error));
    memset(&temp, 0, sizeof(temp));
    if(!file.open(IO_ReadOnly))
    {
               	QMessageBox::warning(this, "file Save Error\n\n", "Can NOT read G_Repor");
     }
    else
    {
	while(!file.atEnd())
	{
	    num = 0;
	    index = 0;
	     memset(&error, 0, sizeof(Error));
	     memset(&temp, 0, sizeof(temp));
	    file.readLine(line, 1000);
	    strcpy(temp, line.ascii());
	    if(error_warning_filter( temp ))
	    {
		strcpy(temp, line.ascii());
		for(int i = 0 ; i < strlen(temp) ; i++)
		{		    
		    if(temp[i] == ':')
		    {
			switch(index)
			{
			case 0:			    
			    strncpy(error.file_name, temp + (i-num), num);
			    if(strcmp(error.file_name, "gcc") == 0 || strcmp(error.file_name, "cc1") == 0)
			    {
				strcpy(error.file_kind, "make error");
				strncpy(error.message, temp + i+1, strlen(temp) - ( i + 1));
				i = strlen(temp);
			     }
			    num = -1;
			    index++;
			    break;
			case 1:			    
			    strncpy(error.file_line, temp + (i-num), num);
			    num = -1;
			    index++;
			    break;
			case 2:
			    strncpy(error.file_col, temp + (i-num), num);
			    if(strcmp(error.file_col, " error") == 0 || strcmp(error.file_col, " warning") == 0)
			    {
				strcpy(error.file_kind, error.file_col);
				strcpy(error.file_col, "");
				strcpy(error.message, temp + i+1);
				num = -1;
				index = index + 2;
			    }
			    else
			    {
				num = -1;
				index++;
			    }
			    
			    break;
			case 3:
			    strncpy(error.file_kind, temp + (i-num), num);
			    strcpy(error.message, temp + i+1);
			    num = -1;
			    index++;
			    break;
			}
		    }
		    num++;
	              }
	     item  = mainform->Error_List->findItem( error.file_name, 0 , Qt::ExactMatch);//if Return == 0 then there is not Error file in Error_List
	     kind.sprintf("%s", error.file_kind);
	     Line.sprintf("%s", error.file_line);
	     col.sprintf("%s", error.file_col);
	     message.sprintf("%s", error.message);
	     
	     if( message.contains("no") && message.contains("new") && message.contains("line")&& message.contains("end")&& message.contains("file") )
	     {
		  WarningNum--;
	     }
	     else if( message.contains("implicit") && message.contains("declaration") && message.contains("of")&& message.contains("function")&& message.contains("__fpurge") )
	     {
		  WarningNum--;	  
	      }
	     else if(item == 0)
	     {
		    mainform->Error_List->insertItem( new QListViewItem(mainform->Error_List, error.file_name));
		    item  = mainform->Error_List->findItem( error.file_name, 0 , Qt::ExactMatch);
		    item->insertItem( new QListViewItem(item, kor(kind), kor(Line), kor(col), kor(message)));
	      }
	     else
	     {
           		    item->insertItem( new QListViewItem(item, kor(kind), kor(Line), kor(col), kor(message)));
	     }
	    }// END : if(line.find("error") || line.find("warnning"));
	}
		
    }
    result.sprintf("Project : %s      Error:    %d , Warning:    %d", mainform->ProName.ascii(), ErrorNum, WarningNum);
    mainform->Error_Num->insertItem ( result, -1 ); 
    mainform->compile_prograss->hide();    
    mainform->Error_Num->show();
    mainform->Error_List->hide();
    mainform->compile_prograss->clear();
    file.close();
}


bool G_Report_Form::error_warning_filter( char temp[1000] )
{
    for(int i = 0 ; i < strlen(temp) ; i++)
    {
	if(strncmp(temp+i, "error", 5) == 0)
	{
	    ErrorNum++;
	    return true;
	}
	if(strncmp(temp+i, "warning", 7) == 0 )
	{
	      WarningNum++;
	    return true;
	}
	if(strncmp(temp+i, "gcc", 3) == 0 )
	{
	      ErrorNum++;
	    return true;
	}
	
    }
    return false;

}


void G_Report_Form::Open_Makefile()
{
    this->setCaption("MakeFile");
   QFile file(mainform->Path + "Makefile");
    if(!file.open(IO_ReadOnly))
    {
             QMessageBox::warning(this, "file Save Error\n\n", "Can NOT read G_Repor");
     }
    else
    {
	QTextStream stream(&file);
	Text_Report->setText(stream.read());
	file.close();
    }
}


void G_Report_Form::Set_fflush_list( QStringList temp )
{
    fflush = temp;
}


