/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.  
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qmessagebox.h>
#include "MainForm.h"
#include "NewFileForm.h"
#include "Make_Project.h"
#include <qfile.h>
#include <string.h> 
#include <qstring.h>  
#include <string.h>   
#include <qtextstream.h> 
#include <qlistview.h>
#include <qstatusbar.h> 
#include <qtextedit.h>
#include <qfiledialog.h> 
#include <qdir.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qwidget.h>
#include <qstringlist.h>

#define kor(str) QString::fromLocal8Bit(str)


void Mk_ProForm::click_cmd_Creat()//Creat  Project
{
    char pro_path[300];
    char pro_name[100];
    memset(&pro_path, 0, sizeof(pro_path));
    memset(&pro_name, 0, sizeof(pro_name));
    if(E_Pro_Name->text().isEmpty())//if Tere is Not Project Name
    {
	QMessageBox::critical(this, "Create Project Error", "Tere is NOT Project Name!! \nSo Can not Create Project!! \nPlease Insert Project NAME!!");
	return;
    }
    else
    {
	Make_Project pro(mainform);//  Declaration of Make_Project Class in Headerfile"Make_Project.h" for Making Project
	strcpy(pro_path, Mk_Path.ascii());
	strcpy(pro_name, E_Pro_Name->text().ascii());
	if( pro.Creat_Project(pro_path, pro_name , "gcc") == -1)// Creat_Project is Member Fuction of Make_Project Class
	    return;
	mainform->Path.sprintf("%s", Mk_Path.ascii());
	mainform->ProName.sprintf("%s.gp", E_Pro_Name->text().ascii());
	if( mainform->history_num < 5 )
	{
	    mainform->ReWrite_History( 0 , mainform->Path+mainform->ProName, -1, "dd");    
	}
	else
	{
	    mainform->ReWrite_History( 0 , mainform->Path+mainform->ProName, mainform->history_num -1, "dd");
	}
	
	this->close();
	
    }
    
}

void Mk_ProForm::click_cmdFileDialog()//Open FileDialog for Saving Project File
{
    QString filename = QFileDialog::getExistingDirectory(QDir::current().path(), this, "get existing directory","Choose a directory", TRUE );//Open File Directory Dialog
    if(!filename.isEmpty())//if Select Directory Path and click the OK comment Button
    {
	Mk_Path.sprintf("%s", filename.ascii());//filename,ascii() -> chage form QString to const char *
	filename.sprintf("%s%s.gp", Mk_Path.ascii(), E_Pro_Name->text().ascii());
	E_Pro_Path->setText(kor(filename));
    }
}

void Mk_ProForm::Change_E_Pro_Name()//This Function is called when The  LineEditor of "E_Pro_Name" is changed
{
    QString name;
    name.sprintf("%s%s.gp", Mk_Path.ascii(), E_Pro_Name->text().ascii());
    E_Pro_Path->setText(name);
}

void Mk_ProForm::init()
{
    E_Pro_Path->setText(QDir::current().path()+"/"); // Set Current Path
    Mk_Path.sprintf("%s", E_Pro_Path->text().ascii());//Store Path
}

void Mk_ProForm::SetMainformpointer(MainForm *fp)//For Getting the Mai  QMessageBox::question(this, "aa", a);nForm pointer
{
    mainform = fp;
}


void Mk_ProForm::MK_Tab_changed()//Open Project
{
    char pro_path[500];
    memset(&pro_path, 0, sizeof(pro_path));
    if(Mk_Tab->indexOf(Mk_Tab->currentPage()) == 1)
    {
	QString filename = QFileDialog::getOpenFileName("/", "Project (*.gp)",  this, "open Project", "Choose a Project" );
	if(filename.isEmpty())
	{
	    Mk_Tab->showPage(Mk_Tab->page(0));
	    return;     
	}
	Make_Project pro(mainform);
	mainform->ProName = Device_FileName_Path(filename);
	mainform->Path.sprintf("%s", Mk_Path.ascii());
	strcpy(pro_path, filename.ascii());
	pro.Load_Project(pro_path);
	mainform->WorkSpace_double_clicked();
	if( mainform->history_num < 5 )
	{
	    mainform->ReWrite_History( 0 , filename, -1, "dd");    
	}
	else
	{
	    mainform->ReWrite_History( 0 , filename, mainform->history_num -1, "dd");
	}
	this->close();	
    }
//
}


QString Mk_ProForm::Device_FileName_Path( QString filename )
{
    char temp[300];
    char str[300]; 
    char real[300]; 	
    sprintf(temp, filename);
    memset(&str, 0, sizeof(str)); 
    memset(&str, 0, sizeof(real)); 
    int len = strlen(temp);// Get filename Lenge //
    for(int i = len-1 ; i > -1 ; i--) // Loop : start-> End of filename , break -> meet first char "/"
    { 
	if(temp[i] == '/') 
	{ 
	    i++; 
	    strcpy(real, temp+i); 
	    strncat(str, temp, i); 
	    break; 
	} 
    }
    Mk_Path.sprintf("%s", str); // store Project Open  or Creat Path
    filename.sprintf("%s", real);//store Project Name
    return filename;//return Project Name
}


QStringList Mk_ProForm::Set_Compilelist( char path[500] )
{
    Make_Project pro(mainform);
    return pro.Set_CompileList(path);
}



