/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qimage.h>
#include <qpixmap.h>
#include <qiconview.h>
#include <qmessagebox.h>
#include <qpushbutton.h>
#include "MainForm.h"  
#include "Mk_ProForm.h" 
#include "a.h"// == Include "Make_Project.h" 
#include <qfile.h>  
#include <string.h>  
#include <qstring.h>
#include <string.h> 
#include <qfiledialog.h>


void NewFileForm::init()
{
        GroupBox2->hide();
         cmd_Back->hide();
}


void NewFileForm::NewFileList_select( QIconViewItem * item )
{
    Define_IconView();
}
 

void NewFileForm::SetMainFormPointer( MainForm *fp )
{
    mainform = fp;
        
    if(mainform->ProItem->text(0) != "  NO Project")
	E_Pro_Name->setText(mainform->ProName);
    else
	E_Pro_Name->setText("None");
}

void NewFileForm::cmd_OK_clicked()
{
    char name[100];
    char path[300];
    memset(&name, 0, sizeof(name));
    memset(&path, 0, sizeof(path));
    if(cmd_OK->text() == "OK")
    {
	if(NewFile_List->currentItem() == 0 )
	    return ;
	Define_IconView();	
    }
    else if(cmd_OK->text() == "Creat Source File")
    {
	if(mainform->WorkSpace->findItem(F_E_FileName->text(), 0, Qt::ExactMatch) != 0)
	{
		 QMessageBox::warning(this, "Same File Name", "The Source File( "+F_E_FileName->text()+ " ) exist!!\nCan NOT Creat this Source File");
		 F_E_FileName->setText("");
		return;
	 }
//////////////////////Creat Source File ///////////////////////////////////////////////////////
	QString temp;
	if(F_E_FileName->text().endsWith(".h"))
	{
	    QMessageBox::warning(this, "File Create Error", "The File( "+F_E_FileName->text()+ " ) is HeaderFile!!\nCan NOT Creat this File");
	    return;
	}
	else if(F_E_FileName->text().endsWith(".c") == false)
	{
	    temp.sprintf("%s%s.c", mainform->Path.ascii(), F_E_FileName->text().ascii());
	    F_E_FileName->insert(".c");
	}
	else 
	{
	    temp.sprintf("%s%s", mainform->Path.ascii(), F_E_FileName->text().ascii());
	}
	
	FILE *fp;
	fp = fopen(temp.ascii(),"w");
	fclose(fp);
///////////////////////////////////////////////////////////////////////////////////////////////
	a pro(mainform);
	temp.sprintf("%s%s", mainform->Path.ascii(), mainform->ProName.ascii());
	strcpy(name, F_E_FileName->text().ascii());//for detecting core dum 
	strcpy(path, temp.ascii());//for detecting core dum 
	if( pro.Add_Source_File(name, path) == -1)
	    return ;
	mainform->Add_TabPage(F_E_FileName->text());//
	this->close();
    }
    else
    {
	if(mainform->WorkSpace->findItem(F_E_FileName->text(), 0, Qt::ExactMatch) != 0)
	{
		 QMessageBox::warning(this, "Same File Name", "The Header File( "+F_E_FileName->text()+ " ) exist!!\nCan NOT Creat this Header File");
		 F_E_FileName->setText("");
		return; 
	 }
//////////////////////////Creat Header File ///////////////////////////////////////////////////////
	QString temp;
	if(F_E_FileName->text().endsWith(".c"))
	{
	    QMessageBox::warning(this, "File Create Error", "The File( "+F_E_FileName->text()+ " ) is Source File!!\nCan NOT Creat this File");
	    return;
	}
	else if(!F_E_FileName->text().endsWith(".h"))
	{
	    temp.sprintf("%s%s.h", mainform->Path.ascii(), F_E_FileName->text().ascii());
    	    F_E_FileName->insert(".h");
	}
	else
	{
	    temp.sprintf("%s%s", mainform->Path.ascii(), F_E_FileName->text().ascii());
	}
	
	FILE *fp;
	fp = fopen(temp.ascii(),"w");
	fclose(fp);
///////////////////////////////////////////////////////////////////////////////////////////////
	a pro(mainform);
	temp.sprintf("%s%s", mainform->Path.ascii(), mainform->ProName.ascii());
	strcpy(name, F_E_FileName->text().ascii());//for detecting core dum 
	strcpy(path, temp.ascii());//for detecting core dum 
	if(pro.Add_Header_File(name, path) == -1)
	    return;
	mainform->Add_TabPage(F_E_FileName->text());
	this->close();
	
    }
}


void NewFileForm::Define_IconView()
{
    switch( NewFile_List->currentItem()->index() )
    {
    case 0:
	mainform->Check_Save();
	mainform->Open_Main_Form();
	this->close();
        	break;
    case 1:
	if(E_Pro_Name->text() == "None")
	{
	    QMessageBox::critical(this, "NO Project", "Tere is not Project \nPlease Creat Project File");
	    return;
	}
	SetProject();
	GroupBox2->show();
	GroupBox1->hide();
	cmd_OK->setText("Creat Source File");
	cmd_Back->show();
	break;
    case 2:
	if(E_Pro_Name->text() == "None")
	{
	    QMessageBox::critical(this, "NO Project", "Tere is not Project \nPlease Creat Project File");
	    return;
	}
	SetProject();
	GroupBox2->show();
	GroupBox1->hide();
	cmd_OK->setText("Creat Header File");
	Label_File->setText("Header File         :");
	cmd_Back->show();
	cmd_Back->show();
	break;
    }

}


void NewFileForm::cmd_Back_clicked()
{
    F_E_FileName->setText("");
    GroupBox2->hide();
    GroupBox1->show();
    cmd_OK->setText("OK");
    Label_File->setText("C Source File      :");
}


void NewFileForm::SetProject()//Creating Project
{
    QString temp;
    char path[300];
    memset(&path, 0, sizeof(path));
    a pro(mainform);
    temp.sprintf("%s%s", mainform->Path.ascii(), mainform->ProName.ascii());
    strcpy(path, temp.ascii());
    pro.Display_Pro_infomation(path);
    temp.sprintf("%s", pro.G_pro.Pro_name);
    F_E_ProName->setText(temp);
    F_E_ProPath->setText(mainform->Path);
    temp.sprintf("%s", pro.G_pro.Compiler);
    F_E_ProCompiler->setText(temp);
}


void NewFileForm::cmd_New_F_Dlg_clicked()
{
        QString filename = QFileDialog::getExistingDirectory(mainform->Path, this, "get existing directory","Choose a directory", TRUE );//Open File Directory Dialog

}
