/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <stdio.h>
#include <qstring.h>
#include <qmessagebox.h> 
#include "MainForm.h"
#include <qfont.h>
#include <qcolor.h>
#include <qwidget.h> 
#include <qrect.h>   
#include <qfile.h>
#include <qtextedit.h> 
#include <qprocess.h>
  

void Terminal_Form::init()
{
    Terminal_Text->installEventFilter(this);
    data_buffer->hide();
} 


void Terminal_Form::destroy()
{   

}


bool Terminal_Form::eventFilter(QObject *obj, QEvent *ev)
{
    
    if(ev->type() == QEvent::KeyPress)
    {
	if(proc->isRunning() == false)
	{ 
		this->close();
	}
	QKeyEvent *k = (QKeyEvent*)ev;
	QString a;
	if(k->key() == 4144 || k->key() == 4094 ||k->key() == 4145 ||k->key() == 4146 ||k->key() == 4147 ||k->key() == 4148 ||k->key() == 4149 ||k->key() == 4150 ||k->key() == 4151 ||k->key() == 4152 ||k->key() == 4153 ||k->key() == 4154 ||k->key() == 4155 ||k->key() == 4134 ||k->key() == 4104 ||k->key() == 4128 ||k->key() == 4129 ||k->key() == 4179 ||k->key() == 4131 ||k->key() == 4114 ||k->key() == 4115 ||k->key() == 4117 ||k->key() == 4116 ||k->key() == 4102 ||k->key() == 4103 ||k->key() == 4113 ||k->key() == 4112 ||k->key() == 4118 ||k->key() == 4119 ||k->key() == 4133)
	{

	}
	else if( k->key() == 4099)//BackSpaceKey
	{
	    if( data_buffer->text().length() != 0 )
	    {
		Terminal_Text->doKeyboardAction(QTextEdit::ActionBackspace); 
		data_buffer->backspace();
	    }
	}
	else if( k->key() == 4100 || k->key() == 4101)//EnterKey
	{
		proc->writeToStdin(data_buffer->text() + "\n" );
		data_buffer->clear();
		Terminal_Text->doKeyboardAction(QTextEdit::ActionReturn);
	 }
	else
	{
	    Terminal_Text->insert(k->text());
	    data_buffer->insert(k->text());
	}
    }
    else
    {
	
    }
}
 

void Terminal_Form::CursorPosition_Changed()
{
    Terminal_Text->moveCursor(QTextEdit::MoveEnd, false);
}


void Terminal_Form::Start_Terminal_Process( QString path )
{
    proc = new QProcess(this);
    proc->addArgument(path);
    connect(proc, SIGNAL(readyReadStdout()), this, SLOT(readFromStdout()));
    connect(proc, SIGNAL(processExited()), this, SLOT(process_end()));
    connect(proc, SIGNAL(wroteToStdin()), this, SLOT(sendFromStdin()));
    connect(proc, SIGNAL(readReadStderr()), this, SLOT(Error()));
    if( !proc->start())
    {
	QMessageBox::critical(this, "error", "error");
	return ;
    }
}

void Terminal_Form::readFromStdout()
{
  Terminal_Text->insert( proc->readStdout());
  
}


void Terminal_Form::process_end()
{
    Terminal_Text->insert("This Excution File is Finished.. Thank You!!");
//    Terminal_Text->setEnabled(false);
}


void Terminal_Form::sendFromStdin()
{
//    QMessageBox::question(this, "aaaa", "aaa");
    Terminal_Text->insert( proc->readStdout());
}


void Terminal_Form::clicked()
{

}


void Terminal_Form::Error()
{
    QMessageBox::question(this, "aa", "aa");
	 
}
