#include <iostream>
#include <stdio.h>
#include <string.h>
//#include "MainForm.h"
#include "Mk_ProForm.h"
#include "NewFileForm.h"
#include "a.h"
#include <qstring.h>
#include <qlistview.h>
#include <qmessagebox.h>

	
typedef struct f_name
{
	char fileName[30];
	struct f_name *node;
}f_name;
typedef struct data
{
	char compiler[10];
	char pro_name[30];
	struct f_name file;
}data;
		
class Auto
{
public:
	f_name file;
	data Make_data;

public:
	Auto(char Path[300]);
	~Auto(){;};
	void Write_MakeFile(char compiler[10], char project[30]);
};

Auto::Auto(char Path[300])
{
	f_name *temp;
	f_name *real;
	File_name filename;
	memset(&file, 0, sizeof(f_name));
	memset(&Make_data, 0, sizeof(data));
	file.node = NULL;
	a pro;	
	FILE *fp;
	fp = fopen( Path , "rb");
	fread(&pro.G_pro, 1, sizeof(Project), fp);
	strcpy(file.fileName, pro.G_pro.Source.name);
	filename = pro.G_pro.Source;
	real = &file;	
	if(strlen(filename.name) != 0)
	{
		while(1)
		{
			if( filename.File_node > 0 )
			{
				fseek(fp, filename.File_node, SEEK_SET);			
				fread(&filename, 1, sizeof(File_name), fp);
				temp = new f_name;
				strcpy(temp->fileName, filename.name);
				temp->node = NULL;
				real->node = temp;
				real = temp;
			}
			else
			{
				break;
			}
		}
	}
















}

void Auto::Write_MakeFile(char compiler[10], char project[30])
{
	FILE *fp;
	f_name temp;

	strcpy(Make_data.compiler, compiler);
	strcpy(Make_data.pro_name, project);
	
	fp = fopen("./Makefile", "w");

	fprintf( fp, "all : %s\n\n", Make_data.pro_name);
	fprintf( fp, "%s : %s.o ", Make_data.pro_name, file.fileName);
	
	if(file.node != NULL)
	{
		temp = *file.node;
		fprintf( fp, "%s.o ",temp.fileName);

		while(1)
		{
			if(temp.node != NULL)
			{
				temp = *temp.node;
				fprintf( fp, "%s.o ",temp.fileName);
			}
			else
			{
				fprintf(fp, "\n");
				break;
			}
		}
	}
	else
	{
		fprintf(fp, "\n");
	}

	fprintf(fp, "\t%s -o %s.o ", Make_data.compiler, file.fileName);
	
	if(file.node != NULL)
	{
		temp = *file.node;
		fprintf( fp, "%s.o ",temp.fileName);

		while(1)
		{
			if(temp.node != NULL)
			{
				temp = *temp.node;
				fprintf( fp, "%s.o ",temp.fileName);
			}
			else
			{
				fprintf(fp, "\n\n");
				break;
			}
		}
	}
	else
	{
		fprintf(fp, "\n\n");
	}

	fprintf(fp, "%s.o : %s.c\n", file.fileName, file.fileName);
	fprintf(fp, "\t%s -o %s.o %s.c\n\n", Make_data.compiler, file.fileName, file.fileName);
	if(file.node != NULL)
	{
		temp = *file.node;

		while(1)
		{
			fprintf(fp, "%s.o : %s.c\n", temp.fileName, temp.fileName);
			fprintf(fp, "\t%s -o %s.o %s.c\n\n", Make_data.compiler, temp.fileName, temp.fileName);
			if(temp.node != NULL)
			{
				temp = *temp.node;
			}
			else
			{
				break;
			}
		}
	}
	fclose(fp);
}

