/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy(). 
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/ 
#include <qbuttongroup.h> 
#include <qmessagebox.h> 
#include <qtextcodec.h>    
#include <qradiobutton.h> 
#include <qwidget.h> 
#include <qtextedit.h>   
#include <qrect.h>   
#include <qfile.h> 
#include <qfont.h>    
#include <qfiledialog.h>  
#include <qtextstream.h> 
#include <qprocess.h>
#include <qlistview.h>
#include <string.h>
#include <stdio.h>
#include <qpopupmenu.h>
#include <qcursor.h>
#include "NewFileForm.h"
#include "Debuger_Form.h"
#include "Mk_ProForm.h"
#include "G_Report_Form.h"
#include "Record_IncludeForm.h"
#include "Terminal_Form.h"
#include "b.h"
#include "G_Studio.h"
#include "Logo_Form.h"


//find History
bool MainForm::Check_exist_File( QString filename )
{
    QString temp;
    QString path;    
    char sentence[300]; 
    memset(&sentence, 0, sizeof(sentence));    
    Mk_ProForm *Mk_form = new Mk_ProForm(this);
    temp = Mk_form->Device_FileName_Path( filename );
    memset(&sentence, 0, sizeof(sentence));
    strncpy(sentence, filename.ascii(), filename.length() - temp.length());
    path.sprintf("%s", sentence);
    QDir dir(path,QString::null, QDir::DirsFirst);
    dir.setMatchAllDirs(true);
    QStringList entries = dir.entryList();
    if(entries.contains(temp) < 1 )
    {
	delete Mk_form;
	return false;
    }
    else
    {
	delete Mk_form;	
	return true;
	
    }

}

void MainForm::ReWrite_History( int add_index, QString add_name, int del_index, QString del_name ){
    QFile file;
    file.setName("/G_Studio/History/History_Project.txt");
    QTextStream stream(&file);
    pro_list_text->clear();
    if(!file.open(IO_ReadOnly))
    {
	file.close();
	pro_list_text->insertParagraph(add_name, 0);
	file.open(IO_WriteOnly);
	stream << pro_list_text->text();
	file.close();
    }
    pro_list_text->setText(stream.read());
    file.close();    
    if(pro_list_text->find( add_name , true, true, true, 0, 0) == true)
    {
	int line, col;
	pro_list_text->getCursorPosition(&line, &col);
	pro_list_text->removeParagraph( line );
	pro_list_text->insertParagraph(add_name, add_index);
	file.open(IO_WriteOnly);
	stream << pro_list_text->text();
	file.close();
    }
    else if( del_index == -1)
    {

	pro_list_text->insertParagraph(add_name, add_index);
	file.open(IO_WriteOnly);
	stream << pro_list_text->text();
	file.close();
    }
    else
    {
	pro_list_text->removeParagraph( del_index );
	pro_list_text->insertParagraph(add_name, add_index);
	file.open(IO_WriteOnly);
	stream << pro_list_text->text();
	file.close();
    }      
}

void MainForm::OpenProjectAction()
{
    if( Check_exist_File(MenuBar->text(0)) == true)
    {
	Open_New_Project( MenuBar->text(0));
    }
    else
    {
	QMessageBox::critical(this, "Not Found File ", "Not Fount File( "+ MenuBar->text(0) + " )");
    }
}


void MainForm::OpenProjectAction1()
{
    if( Check_exist_File(MenuBar->text(1))== true )
    {
	ReWrite_History( 0, MenuBar->text(1), 1, MenuBar->text(1));	
	Open_New_Project( MenuBar->text(1));
    }
    else
    {
	QMessageBox::critical(this, "Not Found File ", "Not Fount File( "+ MenuBar->text(1) + " )");
    }
}


void MainForm::OpenProjectAction2()
{
    if( Check_exist_File(MenuBar->text(2))== true )
    {
	ReWrite_History( 0, MenuBar->text(2), 2, MenuBar->text(2));	
	Open_New_Project( MenuBar->text(2));
    }
    else
    {
	QMessageBox::critical(this, "Not Found File ", "Not Fount File( "+ MenuBar->text(2) + " )");
    }
}


void MainForm::OpenProjectAction3()
{
    if( Check_exist_File(MenuBar->text(3))== true )
    {
	ReWrite_History( 0, MenuBar->text(3), 3, MenuBar->text(3));	
	Open_New_Project( MenuBar->text(3));
    }
    else
    {
	QMessageBox::critical(this, "Not Found File ", "Not Fount File( "+ MenuBar->text(3) + " )");
    }
}


void MainForm::OpenProjectAction4()
{
    if( Check_exist_File(MenuBar->text(4))== true)
    {
	ReWrite_History( 0, MenuBar->text(4), 4, MenuBar->text(4));		
	Open_New_Project( MenuBar->text(4));
    }
    else
    {
	QMessageBox::critical(this, "Not Found File ", "Not Fount File( "+ MenuBar->text(4) + " )");
    }
}

//find init
void MainForm::init()//MainForm first Call Function
{
    
/////////////////////// Set History //////////////////////////
    QPixmap pix("/G_Studio/images/miniproject.png");
    QFile file;
    QString filename;
    file.setName("/G_Studio/History/History_Project.txt");
    QTextStream stream(&file);
    pro_list_text->hide();
    if(!file.open(IO_ReadOnly))
    {
    }
    else
    {
	pro_list_text->setText(stream.read());
	file.close();
	fileMenu->insertSeparator(4);      
	for( int i = pro_list_text->paragraphs()-2 ; i > -1 ; i-- )
	{
	    filename = pro_list_text->text(i).remove( " ", false);
	    fileMenu->insertItem( pix, filename , i ,  4);
	    switch( i )
	    {
	    case 0:
		fileMenu->connectItem(i, this, SLOT( OpenProjectAction()));
		break;
	    case 1:
		fileMenu->connectItem(i, this, SLOT( OpenProjectAction1()));
		break;
	    case 2:
		fileMenu->connectItem(i, this, SLOT( OpenProjectAction2()));
		break;
	    case 3:
		fileMenu->connectItem(i, this, SLOT( OpenProjectAction3()));
		break;
	    case 4:
		fileMenu->connectItem(i, this, SLOT( OpenProjectAction4()));
		break;
	    }
	}
	history_num = pro_list_text->paragraphs()-1 ;
    }
//////////////////////////////////////////////////////////// 
    
///////////////////////  Setting  Widget & Value ////////////////////
    compile_select = false;
    this->hide();
     findAction_flag  = false;
    Logo_Form *logo = new Logo_Form(this);
    logo ->Set_MainForm_Pointer(this);
    logo->move(350, 180);
    logo->show(); 
    logo->Loading(); 
    
    Function_label->hide();
    Fun_ToolTip_flag = false;
    List_Function->hide();
    List_Fun_name->hide();

    list << "#include" << "#define" << "int" << "char" << "double" << "float" << "true" << "false" << "if" << "while" << "void" << "unsigned" << "case"<< "public" << "private" << "private" << "short" << "return" << "static" << "const" << "switch" << "do" << "for" << "switch"<< "else"<<"const" << "static" << "struct" << "typedef" << "sizeof" << "break"<<"long";
    index = 0;
    this->showMaximized();// The form size is Becomed Maximum Size When  it show at first
    ////////////////////////////////////////////////////////
    
    /////////Get WorkSpace Tree Pointer( Project, HeaderFile, SourceFile, MakeFile) ///////////////
    ProItem = WorkSpace->currentItem();
    SourceItem = WorkSpace->findItem("Source File", 0, Qt::ExactMatch);
    HeadItem = WorkSpace->findItem("Header File", 0, Qt::ExactMatch);
    MakeItem = WorkSpace->lastItem();
    SourceItem->setOpen(true);
    HeadItem->setOpen(true); 
    
    /////////////////////////////////////////////////////////////////
    
    //////  TabCotrol Variables ////////////////////////////////////////
    E_enterCode->hide();//hide message Printf("Please Enter the Any KEY");
    text->hide();
    Error_List->hide();
    compile_prograss->hide();
    Error_List->setGeometry(Error_Groupbox->rect());
    Error_Num->setGeometry(Error_Groupbox->rect());
    pText[0] = text;
    pFun_Label[0] = Function_label;
    Text_index = 0;
    for(int i = 0 ; i < 30 ; i++)
    {
	Text_flag[i] = false;
	WorkLine[i] = 0;
    }
    //////////////////////////////////////////////////////////////
   

    
    //////  Show Mk_ProForm is Modal /////////////
    Mk_ProForm *mk_form = new Mk_ProForm(this);
    mk_form->SetMainformpointer(this);
    mk_form->setModal(true);
    mk_form->show();
    
    ///////////////////////////////////////////////
	
}


//find paint event
void MainForm::paintEvent( QPaintEvent * )//Call the Function if the frame changed
{
    QString tt;
    QRect Tab_rect;
    Tab_rect = Tab_Editor->rect();//Get the tab Size( rect )
    QRect Text_rect(Tab_rect.left()+5, Tab_rect.top() +5 , Tab_rect.right() -13, Tab_rect.bottom() -43);
    //Set TextEidt Rect
     for(int i = 0 ; i < Text_index ; i++)
    {
	pText[i]->setGeometry(Text_rect);//Set TextEdit Geometry Using Text_rect
    }
    Error_List->setGeometry(Error_Groupbox->rect());
    Error_Num->setGeometry(Error_Groupbox->rect());
    compile_prograss->setGeometry(Error_Groupbox->rect());
 
}


//find TabPage
//This Fuction is Add the Tab_Page,  This Fuction is Called when the Source File is added 
/****** Variable : QString PageLabel = The name of  Added Source File *******/ 
void MainForm::Add_TabPage(QString PageLabel)
{
////////////////////////////////////// Variables  ///////// ////////////////////////////////////////////////////
    QWidget *pTabPage = NULL;
    QRect Tab_rect = Tab_Editor->rect();//Get the tab Size( rect )
    QRect Text_rect(Tab_rect.left()+5, Tab_rect.top() +5 , Tab_rect.right() -13, Tab_rect.bottom() -43);
    //Set TextEidt Rect
    QString Open_Path;
    QFont font("Sans Serif", 10, QFont::Bold, false);
    QColor color(241,241,200);
    Open_Path.sprintf("%s%s", Path.ascii(), PageLabel.ascii());
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
    
    if(Tab_Editor->label(0) == "None")// if the SourceFile is added at first..( TabPage is added at first)
    {	
	if(!Load_File(Open_Path))
	{
	    FILE *fp; 
	    fp = fopen(Open_Path.ascii(), "w");
	    fclose(fp);	    
	}
	Tab_Editor->changeTab(Tab_Editor->currentPage(), PageLabel); // Change TabPage Label( Source File name ).
	pText[Text_index]->setWordWrap(QTextEdit::NoWrap);
	pText[Text_index]->setGeometry(Text_rect); // Set Geometry Using Text Rect	
	pText[Text_index]->show(); // Show the Hided TextEdit 
	text->show();
	Text_index++; 
	
    }
    else
    {
	pTabPage = new QWidget(this->Tab_Editor); // Creat new Widget of TabPage
	
	pText[Text_index] = new QTextEdit(pTabPage); // Store the Pointer of  TextEdit
	pFun_Label[Text_index] = new QLabel(pTabPage);
	
	if(!Load_File(Open_Path))
	{
	    FILE *fp;
	    fp = fopen(Open_Path.ascii(), "w");
	    fclose(fp); 
	}
	this->Tab_Editor->addTab( pTabPage , PageLabel ); // Add the TabPage
	pText[Text_index]->setGeometry(Text_rect); //  Set Geometry the TextEdit
	pFun_Label[Text_index]->setGeometry(100, 100, 100, 100);
	pFun_Label[Text_index]->hide();
	pFun_Label[Text_index]->setPaletteBackgroundColor(color);
	pFun_Label[Text_index]->setFont(font);
	connect(pText[Text_index] , SIGNAL( textChanged()), this , SLOT(changedFlag()));
	connect(pText[Text_index] , SIGNAL(cursorPositionChanged(int, int)), this , SLOT(setWorkingLine()));
	connect(pText[Text_index] , SIGNAL(contentsMoving(int, int)), this, SLOT(change_textpage()));
	connect(pText[Text_index] , SIGNAL(returnPressed()), this, SLOT(Press_EnterKey()));		
	pText[Text_index]->setWordWrap(QTextEdit::NoWrap);
	Text_index++;
    }

}

//find Load file
bool MainForm::Load_File(QString filename)//if File Open Call this function
{
    QFile file;
    QColor color(100, 11, 40);
    if(!filename.isEmpty())
    {
	  file.setName(filename);
	  if(!file.open(IO_ReadOnly))
	  {
	      QMessageBox::warning(this, "File ("+ filename +") Open Error", "Can NOT open File ( "+ filename +" )\nSo Load Empty File on this FileName");
	      return false;
	 }
	 
	 QTextStream stream(&file);
	 pText[Text_index]->setText(stream.read());
	 file.close();
	 Text_flag[Text_index] = 0;
	 QStringList::ConstIterator it = list.constBegin(); 
	 while(it != list.constEnd()) //list : Operation List
	{
	    pText[Text_index]->moveCursor( QTextEdit::MoveHome, false);
	    while(1)
	    {
		index = 2; //Color return index
		if(pText[Text_index]->find(*(it), true, true, true, 0, 0) == false)
		    break;
		pText[Text_index]->setColor(color);
		pText[Text_index]->setBold(true);
	    }
	    ++it; 
	}
	 index = 0;
	 return true;	 
     }
    return false;

}

//find file new
void MainForm::fileNew()//Opne NewFileForm
{
    NewFileForm *new_form = new NewFileForm(this);
    new_form->SetMainFormPointer(this);    
    new_form->setModal(true);
    new_form->show();
}

//find file open
void MainForm::fileOpen()
{
     if( ProItem->text(0) == "  NO Project")
    {
	QMessageBox::critical(this, "NO Project", "There is not Poject!!\nPlease load & create the Project file!!");
	return ;	
    }
              char temp1[300];
	char temp2[100];
	memset(&temp1, 0, sizeof(temp1));
	memset(&temp2, 0, sizeof(temp2));
              QString temp;//Project Name
	QString add_path;
    	QString filename = QFileDialog::getOpenFileName(Path, "Source & Header (*.c *.h)",  this, "open Project & Source & Header File", "Choose a Project" );
	if(!filename.isEmpty())
	{
	    b pro(this);
	    if(filename.endsWith(".h"))//if  open file is selected Header file
	    {
		Mk_ProForm *Mk_form = new Mk_ProForm(this);
		temp = Mk_form->Device_FileName_Path( filename );
		if(WorkSpace->findItem(temp, 0,Qt::ExactMatch) != 0)
		{
		    QMessageBox::warning(this, "Same File Name", "The Header File( "+temp+ " ) exist!!\nCan not open this Header File");
		    delete Mk_form;
		    return;
		 }
		if(Path != Mk_form->Mk_Path) 
		{
		    system("cp "+ filename + " " + Path );
		    //if different file path , copy current Path
		}
		Add_TabPage(temp);
		delete Mk_form;
		//////////////////////////////add project header file/////////////////////////////////	
		add_path.sprintf("%s%s", Path.ascii(), ProName.ascii());
		strcpy(temp1, add_path.ascii());
		strcpy(temp2, temp.ascii());
		pro.Add_Header_File(temp2, temp1);
		///////////////////////////////////////////////////////////////////////////////////
	    }
	    else if(filename.endsWith(".c"))//C File
	    {
		Mk_ProForm *Mk_form = new Mk_ProForm(this);
		temp = Mk_form->Device_FileName_Path( filename );
		if(WorkSpace->findItem(temp, 0,Qt::ExactMatch) != 0)
		{
		    QMessageBox::warning(this, "Same File Name", "The Source File( "+temp+ " ) exist!!\nCan not open this Source File");
		    delete Mk_form;
		    return;
		 }		
		if(Path != Mk_form->Mk_Path)
		{
		    system("cp "+ filename + " " + Path );
		    //if different file path , copy current Path		    
		}
		Add_TabPage(temp);

		delete Mk_form;

		//////////////////////////////add project Source file/////////////////////////////////	
		add_path.sprintf("%s%s", Path.ascii(), ProName.ascii());
		strcpy(temp1, add_path.ascii());
		strcpy(temp2, temp.ascii());
		pro.Add_Source_File(temp2, temp1);
		///////////////////////////////////////////////////////////////////////////////////

	    }
	}
    
}


//find filesave
void MainForm::fileSave()
{
    QString filename;
    //tabLabel()
    QFile file;
    for(int i = 0 ; i < Text_index; i++)
    {
	filename.sprintf("%s%s", Path.ascii(), Tab_Editor->label(i).ascii());
	file.setName(filename);
	if(!file.open(IO_WriteOnly))
	{
                	QMessageBox::warning(this, "file Save Error\n\n", filename);
	 }
	else
	{
	    QTextStream stream(&file);
	    stream << pText[i]->text(); 
	    file.close();
	    Text_flag[i] = 0;
	}
    }
}

void MainForm::editUndo()
{

}


void MainForm::editRedo()
{

}

void MainForm::editCut()
{

}


void MainForm::editCopy()
{

}


void MainForm::editPaste()
{

}

//find Tab event
void MainForm::Next_TabAction_clicked()
{
    if( Tab_Editor->count() -1 == Tab_Editor->currentPageIndex())
	Tab_Editor->showPage(Tab_Editor->page(0));
    else
    {
	Tab_Editor->showPage(Tab_Editor->page(Tab_Editor->currentPageIndex()+1));	
    }
}

//find code find
void MainForm::editFind()
{
    if( findAction_flag == true )
    {
	pText[ Tab_Editor->indexOf(Tab_Editor->currentPage()) ]->moveCursor(QTextEdit::MoveHome, false);
	findAction_flag = false;
    }
    if(pText[ Tab_Editor->indexOf(Tab_Editor->currentPage()) ]->find( find_text->text() , true, true, true, 0, 0) == false)
    {
	QMessageBox::critical(this, "NOT FOUND", "NOT FOUND");
	findAction_flag = true;
	return ;
    }
  
}

void MainForm::find_text_changed()
{
    findAction_flag = true;
}

void MainForm::helpAbout()
{
    G_Studio_Form *g = new G_Studio_Form(this);
    g->show();
}



void MainForm::Open_Main_Form()
{
    Check_Save();
    QListViewItem *item;
    bool flag = false;
    WorkSpace->setCurrentItem( ProItem );
    while(item != MakeItem)
    {
	if( flag == false)
	    WorkSpace->setCurrentItem(HeadItem);
	else
	    WorkSpace->setCurrentItem(SourceItem);
	item = WorkSpace->currentItem()->itemBelow();
	if( item == SourceItem)
	    flag = true;
	WorkSpace->setCurrentItem(item);
	if( item == ProItem || item == SourceItem || item == HeadItem || item == MakeItem )
	{
	}
	else
	{
	    Delete_Tab_Workspace();
	}
    }
    Inisialize_MainWidget();
    ProItem->setText( 0 , "  NO Project");

    Mk_ProForm *mk_form = new Mk_ProForm(this);
    mk_form->SetMainformpointer(this);
    mk_form->setModal(true);
    mk_form->show();
    
}


void MainForm::WorkSpace_double_clicked()//When Someone double click , Show Tap Page of  double clicked Source File
{
    if(WorkSpace->currentItem() == ProItem || WorkSpace->currentItem() == SourceItem || WorkSpace->currentItem() == HeadItem )
    {
	    if(SourceItem->isOpen())
		SourceItem->setPixmap( 0, QPixmap::fromMimeSource( "openfolder.png" ) );
	    else
		SourceItem->setPixmap( 0, QPixmap::fromMimeSource( "folder1.png" ) );
	    if(HeadItem->isOpen())
		HeadItem->setPixmap( 0, QPixmap::fromMimeSource( "openfolder.png" ) );
	    else
		HeadItem->setPixmap( 0, QPixmap::fromMimeSource( "folder1.png" ) );

	return;
    }
    else if(WorkSpace->currentItem() == MakeItem)
    {
    	G_Report_Form *g_report = new G_Report_Form(this);
	g_report->SetMainFormPointer(this);
	g_report->setModal(true);
	g_report->Open_Makefile();
	g_report->show();
    }
    else
    {
	for(int i = 0 ; i < Text_index ; i++)
	{
	    if(WorkSpace->currentItem()->text(0) == Tab_Editor->label(i))	    
	    {
		Tab_Editor->showPage(Tab_Editor->page(i));// Show Tap Page
		break;
	    }
	}
    }

}


void MainForm::changedFlag()// Call this Function when The Text Editor is chaged 
{
    
    QString a;
    Text_flag[Tab_Editor->indexOf(Tab_Editor->currentPage())] = 1; // To Jerge Text Store
    int page_index = Tab_Editor->indexOf(Tab_Editor->currentPage());  
    
 
  switch(index)
    {
    case 0:
	;
	break;
    case 1:
	return;
	break;
    case 2:
	return;
	break;
    }
        
    QColor color(100, 11, 40);
    QString b;
    QString c;
    QString d;
    char Function[100];
    int i;
    int j;
    int k = 0;
    int line, col;
    char temp[1000];
    char temp1[200];// == a
    char temp2[200];// == b
    char temp3[200];// == c
    char temp4[200];// == d
    char key[2];
    pText[page_index]->getCursorPosition(&line, &col);
    memset(&Function, 0, sizeof(Function)); 
    memset(&temp4, 0, sizeof(temp4));    
    memset(&temp3, 0, sizeof(temp3));    
    memset(&key, 0, sizeof(key));    
    memset(&temp2, 0, sizeof(temp2));    
    memset(&temp, 0, sizeof(temp));
    memset(&temp1, 0, sizeof(temp1));
    a = pText[page_index]->text(line);
    strcpy(temp, a.ascii());
    strncpy(key, temp+col-1, 1);
    current_keydown.sprintf("%s",key);
/////////////// For Tab Function ////////////////////////////////////////////////////////    
    if(current_keydown == "}")
   {
	index = 1;
	int i = 0;
	bool flag = true;
	int count = 1;
	char line_sentence[1000];
	char empty_space[100];
	memset(&line_sentence, 0, sizeof(line_sentence));
	strcpy(line_sentence, pText[page_index]->text(line - i).ascii());
	for( int w = 0; w < strlen(line_sentence); w++)
	{
	    if( line_sentence[w] == '}')
	    {
		i++;
		memset(&line_sentence, 0, sizeof(line_sentence));
		strcpy(line_sentence, pText[page_index]->text(line - i).ascii());
		break;
	    }
	    else if( line_sentence[w] == ' ' || line_sentence[w] == '	' )
	    {
		;
	    }
	    else
	    {
		flag = false;
		break;
	    }
	}	
	while(flag)
	{
	    memset(&line_sentence, 0, sizeof(line_sentence));
	    strcpy(line_sentence, pText[page_index]->text(line - i).ascii());
	     for( int j = 0 ; j < strlen(line_sentence); j++)
	    {
                            if(line_sentence[j] == '/' && line_sentence[j+1] == '/')
		{
		    break;	    
		}
		else if( line_sentence[j] == '{')
		{
		    count--;
		}
		else if( line_sentence[j] == '}')
		{
		    count++;
		}		
	    }
	    if(count == 0)
	    {
		for(int k = 0 ; k <	strlen(line_sentence); k++)
		{
		    if( line_sentence[k] != ' ' && line_sentence[k] != '	')
		    { 
			memset(&empty_space, 0, sizeof(empty_space));
			strncpy(empty_space, line_sentence, k);
			break;
		    }
		}
		pText[page_index]->setCursorPosition(line, col-1);
		pText[page_index]->moveCursor(QTextEdit::MoveLineStart, true);
		pText[page_index]->del();
		pText[page_index]->insertAt(empty_space, line, 0);
		pText[page_index]->setCursorPosition(line, strlen(empty_space)+1);
		break;
	    }
	    if( (line - i) == 0 )
		break;
	    i++;
	}
	index = 0;
    }
////////////////////////////////////////////////////////////////////////////////////////////
    if(pText[page_index]->color ().operator==( Qt::red ))//if  case of '//' is return;
    {
	if( col == 0 || col == 1)
	{
	    index = 2;
	    if(col == 1)
		pText[page_index]->moveCursor(QTextEdit::MoveBackward, true);
	    
	        pText[page_index]->setColor(Qt::black);
	        pText[page_index]->setBold(false);
	        pText[page_index]->removeSelection(0);
	        pText[page_index]->setCursorPosition(line, col);
	    }
	index = 0;
	return;
    }    
   
    
    
    for(i = col-1 ; i > -1 ; i--)
    {
	if(temp[i] == ' ' || temp[i] == '	')
	    break;
    }
    i++;
    
    
    for(j = i+1 ; j < strlen(temp); j++)
    {
	if(temp[j] == '<' || temp[j] == '(')
	{
	    	strncpy(temp2, temp+i, j - i);
		b.sprintf("%s", temp2);
		k = j;
	}
	if(temp[j] == ' ' || temp[j] == '	')
	    break;
	
    }

    strncpy(temp1, temp+i, j - i);

         
     if(pFun_Label[page_index]->isHidden() == false)
    {	

	 strcpy(Function , List_Fun_name->text(List_Function->index(List_Function->findItem(pFun_Label[page_index]->text(), 1))).ascii());
	 strcat(Function , "(");
	 if(a.contains(Function) == 0)
	     pFun_Label[page_index]->hide();
     }
         a.sprintf("%s", temp1);
     if(current_keydown == "(")
    {
	strncat( Function, a.ascii(), a.length()-1 );
	if(List_Fun_name->findItem(Function, 1) != 0)
	    Create_Fun_ToolTip(List_Function->text(List_Fun_name->index(List_Fun_name->findItem(Function, 1))));
    }
     if(current_keydown == ")" && pFun_Label[page_index]->isHidden() == false)
	 pFun_Label[page_index]->hide();

     
     if(k != 0)
    {
	strncpy(temp3, temp+k+1, j - k-1);
	c.sprintf("%s", temp3); 
    }
    
    
    if(current_keydown == " ")//when the keyboad action is spacebar , the word  located beside of current cursor  is stored in QString d 
    {
	 for(k = i-2 ; k > -1 ; k--)
	{
	     if(temp[k] == ' ' || temp[k] == '	')
		 break;
	 }
	 k++;
	 strncpy(temp4 , temp+k, i - k-1);
	 d.sprintf("%s", temp4);
    }
     if(list.contains(d) == 1 && current_keydown == " ")
    {	
	    index = 2;
	    pText[page_index]->moveCursor(QTextEdit::MoveBackward, false);
    	    pText[page_index]->moveCursor( QTextEdit::MoveWordBackward, true );
	    pText[page_index]->setBold(true);
	    pText[page_index]->setColor(color);
	    pText[page_index]->removeSelection(0);
	    pText[page_index]->setCursorPosition(line, col);
	    index = 0;
	    return ;
    }
    else if(list.contains(d) == 0 && current_keydown == " ")
    {
	 pText[page_index]->moveCursor(QTextEdit::MoveBackward, false);
	if(pText[page_index]->bold() )
	{
	    pText[page_index]->moveCursor(QTextEdit::MoveWordBackward, true);
	    if( list.contains(pText[page_index]->selectedText()) == 0 && pText[page_index]->selectedText().contains(" ") > 0)
	    {
		pText[page_index]->removeSelection(0);
		pText[page_index]->setCursorPosition(line, col);	
		return;
	    }
	    else
	    {
		index = 2;
		pText[page_index]->setBold(false);
		pText[page_index]->setColor(Qt::black);
		pText[page_index]->removeSelection(0);
		pText[page_index]->setCursorPosition(line, col);
		index = 0;
	    }
	}
	else
	{
    	    pText[page_index]->removeSelection(0);
	    pText[page_index]->setCursorPosition(line, col);
	}
    }
    
     if(list.contains(b) == 1 && pText[page_index]->bold() && strlen(temp1) == strlen(temp2)+1)
    {
	index = 2;
	pText[page_index]->moveCursor( QTextEdit::MoveBackward, true );
	pText[page_index]->setBold(false);
	pText[page_index]->setColor(Qt::black);
	pText[page_index]->removeSelection(0);
	pText[page_index]->setCursorPosition(line, col);
	index = 0;	
    }
    else if(list.contains(c) == 1)
    {
	index = 2;
	pText[page_index]->moveCursor(QTextEdit::MoveWordForward, false);
	for(k = 0 ; k < strlen(temp3)+1 ; k++)
	    pText[page_index]->moveCursor(QTextEdit::MoveBackward, true);
	pText[page_index]->setColor(color);
	pText[page_index]->setBold(true);
	pText[page_index]->removeSelection(0);
	pText[page_index]->setCursorPosition(line, col);
	index = 0;

    }
    else if(list.contains(a) == 1)
    {
	index = 1;	
	pText[page_index]->moveCursor(QTextEdit::MoveWordForward, false);	
	pText[page_index]->moveCursor(QTextEdit::MoveBackward, true);
	pText[page_index]->moveCursor(QTextEdit::MoveWordBackward, true);
	pText[page_index]->setColor(color);
	pText[page_index]->setBold(true);
	pText[page_index]->removeSelection(0);
	pText[page_index]->setCursorPosition(line, col);
	index = 0;
    }
    else if(strlen(temp1) == 1 && (a.contains("<") == 1 || a.contains("(") == 1))
    {
	index = 2;	
	
	pText[page_index]->moveCursor( QTextEdit::MoveBackward, true );
	pText[page_index]->setBold(false);
	pText[page_index]->setColor(Qt::black);
	pText[page_index]->removeSelection(0);
	pText[page_index]->setCursorPosition(line, col);
	index = 0; 
    }
    else if(list.contains(a) == 0 && pText[page_index]->bold())
    {
	if(strlen(temp1) > 1)
	{
	    index = 2;
	    pText[page_index]->moveCursor( QTextEdit::MoveWordForward, false );
	    pText[page_index]->moveCursor(QTextEdit::MoveBackward, true);
	    pText[page_index]->moveCursor( QTextEdit::MoveWordBackward, true );
	    pText[page_index]->setBold(false);
	    pText[page_index]->setColor(Qt::black);
	    pText[page_index]->removeSelection(0);
	    pText[page_index]->setCursorPosition(line, col);
	    index = 0;
	}
	else
	{
	    index = 2;
	    pText[page_index]->moveCursor(QTextEdit::MoveForward, true);
	    pText[page_index]->setBold(false);
	    pText[page_index]->setColor(Qt::black);
	    pText[page_index]->removeSelection(0);
	    pText[page_index]->setCursorPosition(line, col);
	    index = 0;
	}
    }
    else if(list.contains(b) == 1 && (current_keydown == "(" || current_keydown == "<")  )
    {
	index = 1;
	pText[page_index]->moveCursor(QTextEdit::MoveWordBackward, false);
	for(k = 0 ; k < strlen(temp2) ; k++)
	pText[page_index]->moveCursor(QTextEdit::MoveForward, true);
	pText[page_index]->setColor(color);
	pText[page_index]->setBold(true);
	pText[page_index]->removeSelection(0);
	pText[page_index]->setCursorPosition(line, col);
	index = 0;
	
    }
    else
    {
	pText[page_index]->setColor(Qt::black);
	pText[page_index]->setBold(false);
    }
   
    
}

bool MainForm::Check_Save()
{
    QString filename;
    QFile file;
    for(int i = 0 ; i < Text_index ; i++)
    {
	if(Text_flag[i] == true)
	{
	     switch (QMessageBox::question(this, "Save", "Do you want to save File ("+Tab_Editor->label(i)+")!!" , QMessageBox::Yes, QMessageBox::No ))
	    {
	    case 3:
		filename.sprintf("%s%s", Path.ascii(), Tab_Editor->label(i).ascii());
		file.setName(filename);
		if(!file.open(IO_WriteOnly))
		{
		    QMessageBox::warning(this, "file Save Error\n\n", filename);
		}
		else
		{
		    QTextStream stream(&file);
		    stream << pText[i]->text();
		    file.close();
		    Text_flag[i] = 0;
		}
		break;
	    case 4:
		;
		break;
	    case 2:
		return false;
		break;
	    }
	 }
    }
    return true;

}




void MainForm::Auto_MakeFile()//Path When the project copile... this function make the MakeFile..
{
    compile_select = false;
    if(ProItem->text(0) == "  NO Project")//if No Project
    {
	QMessageBox::warning(this, " Project Error ", "No Project");
	return ;	
    }
    fileSave();  //All file save before Compiling
    char sentence[300];
    memset(&sentence, 0, sizeof(sentence));
    QStringList list;// List of c File
    QString pro_path;
    QString exe_file;
    int len = strlen(ProName.ascii());
    strncat(sentence, ProName.ascii(), len-3); 
    exe_file.sprintf("%s", sentence);
    char PATH[500];
    memset(&PATH, 0, sizeof(PATH));
    pro_path.sprintf("%s%s", Path.ascii(), ProName.ascii()); 
    strcpy(PATH, pro_path.ascii());
    b pro(this);
    list = pro.Set_CompileList(PATH);
    system("rm " + Path +exe_file);
    QString Compiler;//Compiler
    Compiler.sprintf("%s ", pro.G_pro.Compiler);    
    
    QStringList::ConstIterator it = list.constBegin();
    Project_Setting *pro_set = new Project_Setting(this);
    
    if(pro.Display_Project_Option(pro_set, PATH) == -1)
    {
	delete pro_set;
	return;
    }
    
    system("rm " + Path + exe_file);// Delete Excution File Befor Compile
    
              FILE *fp; 
	pro_path.sprintf("%s%s", Path.ascii(), "Makefile");
	fp = fopen(  pro_path.ascii() , "w"); 
	fprintf( fp, "all : %s\n\n", exe_file.ascii());
	fprintf( fp, "%s : ", exe_file.ascii());
	 
	while(it != list.constEnd())
	{
	    fprintf(fp, "%s.o ", (*it).ascii());
	    ++it;
	}
	
	fprintf(fp, "\n"); 
	it = list.constBegin();
	fprintf(fp, "\t%s%s%s ", Compiler.ascii(), pro_set->Make_Option_Line(0).ascii(), exe_file.ascii());
	
	while(it != list.constEnd())
	{
	    fprintf(fp, "%s.o ", (*it).ascii());
	    ++it;
	}
	fprintf(fp, "%s\n\n\n\n", pro_set->Make_Libaray_Line(0).ascii()); 
	it = list.constBegin();
	int i;
	QString temp;
	while(it != list.constEnd())
	{
	    for(i = 0 ; i < pro_set->Tab_Index ; i++)
	    {
		temp.sprintf("%s.c", (*it).ascii());
		if(strcmp(temp.ascii(), pro_set->File_Tab->label(i).ascii()) == 0)
		    break;
	     }
	    fprintf(fp, "%s.o : %s.c\n", (*it).ascii(), (*it).ascii());
	    fprintf(fp, "\t%s%s%s.o %s.c %s\n\n", Compiler.ascii(), pro_set->Make_Option_Line(i).ascii(), (*it).ascii(), (*it).ascii(), pro_set->Make_Libaray_Line(i).ascii());
	     ++it;
	}
	delete pro_set;
	fclose(fp);

 
               
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	Error_Num->clear();
	Error_List->clear();
	G_Report_Form *g_report = new G_Report_Form(this);
	g_report->SetMainFormPointer(this);
	g_report->Make();
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
}


void MainForm::make_Compile()
{
     if( ProItem->text(0) == "  NO Project")
    {
	QMessageBox::critical(this, "NO Project", "There is not Poject!!\nPlease load & create the Project file!!");
	return ;	
    }
    Auto_MakeFile();
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
    while( exe_proc->isRunning())
    {
	;
    }
    char sentence[300]; 
    memset(&sentence, 0, sizeof(sentence));
    QString exe_file;
    QDir dir(Path,QString::null, QDir::DirsFirst);
    int i =0;
    dir.setMatchAllDirs(true);
    QStringList entries = dir.entryList();
    int len = strlen(ProName.ascii());
    strncat(sentence, ProName.ascii(), len-3); 
    if(entries.contains(sentence) < 1 && compile_select == false)
    {
	Auto_MakeFile();
	return;	
    }
    char CodeLine[1000];
    bool main_flag = false;
    QString main_code;
    index = 2;
    for( File_index = 0 ; File_index < Text_index ; File_index++) // Start Checking All Files in Project
    {	
	Tab_Editor->showPage(Tab_Editor->page(File_index));// Show Debuger page
	if( Tab_Editor->tabLabel(Tab_Editor->page(File_index)).endsWith(".c"))
	{
	    for( Line_index = 0 ; Line_index < pText[File_index]->paragraphs () ; Line_index++)// Start Checking All Lines in Project
	    {
		if(Function_FSA( pText[File_index]->text(Line_index)) == true)//Searching Function
		{
		    main_flag = Find_main_Func();
		    if( main_flag == true )
		    {
			index = 2;
			Func_End_FSA();
			memset(&CodeLine, 0, sizeof(CodeLine));
			strcpy(CodeLine, pText[File_index]->text(Line_index).ascii());
			for(int i = 0 ; i < strlen(CodeLine) ; i++)
			{
			    if(CodeLine[i] == '}')
			    {
				pText[File_index]->insertAt( E_enterCode->text(), Line_index, i);
				Auto_MakeFile();
				index = 0;
				return ;
			    }	
			
			}
		    }
		}    
	    }
	}
    }//Write Makefile and do make
    index = 0;

}
QListViewItem * MainForm::send_Source_Item_Pix( QString filename )
{
    QListViewItem *item = new QListViewItem(SourceItem, filename);
    item->setPixmap( 0, QPixmap::fromMimeSource( "SourceFile.png" ) );
    return item;
}


QListViewItem * MainForm::send_Header_Item_Pix( QString filename )
{
    QListViewItem *item = new QListViewItem(HeadItem, filename);
    item->setPixmap( 0, QPixmap::fromMimeSource( "HeadFile.png" ) );
    return item;

}


void MainForm::BuildCompileAction()
{ 

}


void MainForm::BuildExecutionAciton()
{
     if( ProItem->text(0) == "  NO Project")
    {
	QMessageBox::critical(this, "NO Project", "There is not Poject!!\nPlease load & create the Project file!!");
	return ;	
    }
    char sentence[300]; 
    memset(&sentence, 0, sizeof(sentence));
    QString exe_file;
    QDir dir(Path,QString::null, QDir::DirsFirst);
    int i =0;
    dir.setMatchAllDirs(true);
    QStringList entries = dir.entryList();
    int len = strlen(ProName.ascii());
    strncat(sentence, ProName.ascii(), len-3); 
    if(entries.contains(sentence) < 1 && compile_select == false)
    {
	Auto_MakeFile();
	return;	
    }
    else if(entries.contains(sentence) < 1 && compile_select == true)
    {
	compile_one_file();
	return ;    
    }
    exe_file.sprintf("%s%s",Path.ascii(), sentence);
    system( "gnome-terminal -title="+Path+ProName+" -x "+ exe_file);
}


void MainForm::BuildG_ReportAction()
{
    if( ProItem->text(0) == "  NO Project")
    {
	QMessageBox::critical(this, "NO Project", "There is not Poject!!\nPlease load & create the Project file!!");
	return ;	
    }
    G_Report_Form *g_report = new G_Report_Form(this);
    g_report->SetMainFormPointer(this);
    g_report->OpenReport();
    g_report->show();
}





void MainForm::Error_Num_Listbox_DBclicked()
{
    Error_List->show();
    Error_Num->hide();
}


void MainForm::setWorkingLine()
{
    switch(index)
    {
    case 0:
	;
	break;
    case 1:
	return;
	break;
    case 2:
	return;
	break;
    }
    
    QColor color(209, 240, 248);
    QString Word;
    QString LineCol;
    pText[Tab_Editor->indexOf(Tab_Editor->currentPage()) ]->getCursorPosition(&Line, &Col);
    LineCol.sprintf("( FileName : %s ) Line : %d , Col : %d", Tab_Editor->tabLabel(Tab_Editor->currentPage()).ascii(), Line + 1, Col + 1);
    Label_Line_Col->setText(LineCol);
    if(Line != WorkLine[Tab_Editor->indexOf(Tab_Editor->currentPage())])//Setting Working LIne
    {
	pText[Tab_Editor->currentPageIndex()]->setParagraphBackgroundColor(WorkLine[Tab_Editor->currentPageIndex()], Qt::white);
	WorkLine[Tab_Editor->currentPageIndex()] = Line;
	pText[Tab_Editor->currentPageIndex()]->setParagraphBackgroundColor(WorkLine[Tab_Editor->currentPageIndex()], color);
    }

}

void MainForm::MarkError()//Printf Error Report ( Red Line)
{    
		   
    QColor error_color(254, 125, 122);
    QListViewItem *item;
 
    if(Error_List->currentItem()->parent() != 0)
    {	
	item = Error_List->currentItem()->parent();		
    }
    else
    {
	pText[Tab_Editor->indexOf(Tab_Editor->currentPage())]->setParagraphBackgroundColor(Error_Line, Qt::white);
	Error_Line = -1;
	item = Error_List->currentItem();	
    }
    for(int i = 0 ; i < Text_index ; i++)
    {
	if(item->text(0) == Tab_Editor->label(i))	    
	{
	    Tab_Editor->showPage(Tab_Editor->page(i));// Show Tap Page
	    break; 
	 }
    }
    if(Error_List->currentItem()->parent() != 0)
    {
	if(Error_Line != Error_List->currentItem()->text(1).toInt(0, 10) - 1)
	{
	    pText[Tab_Editor->indexOf(Tab_Editor->currentPage())]->setParagraphBackgroundColor(Error_Line, Qt::white);
    	    Error_Line = Error_List->currentItem()->text(1).toInt(0, 10) - 1;
	    pText[Tab_Editor->indexOf(Tab_Editor->currentPage())]->setCursorPosition( Error_Line , 0);	    
	    pText[Tab_Editor->indexOf(Tab_Editor->currentPage())]->setParagraphBackgroundColor(Error_Line, error_color);
	}
	
    }
}


void MainForm::Press_EnterKey()
{
    index = 1;
    int temp_line, line, col, flag = 3;
    QString temp;
    char Empty_Space[1000];
    char comment_line[1000];
    memset(&comment_line, 0 , sizeof(comment_line));    
    memset(&Empty_Space, 0 , sizeof(Empty_Space));        
    int text_index = Tab_Editor->indexOf(Tab_Editor->currentPage());
    pText[text_index]->getCursorPosition( &line, &col );
    temp_line = line;
    strcpy(comment_line, pText[text_index]->text(line-1).ascii());
    
    for(int j = 0 ; j < strlen(comment_line); j++)
    {
	if( comment_line[j] == '/' && comment_line[j+1] == '/' )
	{
	    flag = 0;
	    break;
	}
	else if( comment_line[j] == '{' )
	{
	    flag = 1; // sentance of ' { '
	    break;
	}
	else if(comment_line[j] == ';')
	{
	    flag = 2;	  	    
	    break;
	}
	else if(comment_line[j] == '}')
	{
	    flag = 5;
	    break;
	}
	else if(comment_line[j] == ')')
	{
  	    flag = 5;
	    break;  
	}  
	else if((comment_line[j] == ' ' || comment_line[j] == '	' ) && flag == 3)
	{
	    flag = 3;
	}
	else
	{
	    flag = 4;
	}
	
	if(flag == 3 && j == strlen(comment_line) -1)
	{
	    memset(comment_line, 0, sizeof(comment_line));
    	    temp_line--;	    
	    if(temp_line == 0 )
	    {
		flag = 4;
		break;
	    }
	    strcpy(comment_line, pText[text_index]->text(temp_line-1).ascii()); 
	    j = 0;
	}
    }
    
    for(int i = 0 ; i < strlen(comment_line); i++)
    {
	if((comment_line[i] != ' ' && comment_line[i] != '	' ) || i == strlen(comment_line) -1 )
	{
	    strncpy(Empty_Space, comment_line, i);
	    temp.sprintf("%s", Empty_Space);
	    if( flag == 0 || flag == 4)
	    {
		
	    }
	    else if( flag == 1)
	    {
		pText[text_index]->insertAt( temp + "\t" , line, 0);
		pText[text_index]->setCursorPosition(line, strlen(temp)+1);
	    }
	    else if( flag == 2 || flag == 5)
	    {
		pText[text_index]->insertAt( temp , line, 0);
		pText[text_index]->setCursorPosition(line, strlen(temp));		
	    }
	    break;
	}
		    
    }
    index = 0;
}

void MainForm::projectProjectSettingAction()
{
    if( ProItem->text(0) == "  NO Project")
    {
	QMessageBox::critical(this, "NO Project", "There is not Poject!!\nPlease load & create the Project file!!");
	return ;	
    }
    char path[300];
    memset(path, 0, sizeof(path));
    strcat(path, Path.ascii());
    strcat(path, ProName.ascii());
    Project_Setting *pro_set = new Project_Setting(this);
    b pro(this);
    if(pro.Display_Project_Option(pro_set, path) == -1)
    {
	delete pro_set;
	return;
    }
    pro_set->SetMainFormPointer(this);
    pro_set->E_File_Name->setText(ProName); 
    pro_set->setModal(true);
    pro_set->show();
}


bool MainForm::Rewrite_Project_Option( QStringList list )
{
 
    QString temp;
    char pro_path[300];
    b pro(this);
    memset(&pro_path, 0, sizeof(pro_path));
    temp.sprintf("%s%s", Path.ascii(), ProName.ascii());
    strcpy(pro_path, temp.ascii());
    if(pro.Rewrite_Project_Option(list, pro_path) == 0)
	return true;
    
    return false;
    
}


void MainForm::Record_Clicked()
{
    Record_IncludeForm *record_form = new Record_IncludeForm(this);
    record_form->setModal(true);
    record_form->Set_MainForm_Pointer(this);
    record_form->show();
}



void MainForm::change_textpage()
{
    Fun_ToolTip_flag = true;
}


void MainForm::Create_Fun_ToolTip(QString Fun_name)
{
   int text_index = Tab_Editor->indexOf(Tab_Editor->currentPage());
   int line;
   int col;
   int len;
   int col_len = 0;
   int last_line;
   int last_col;
   char temp[300];
   memset(&temp, 0, sizeof(temp));
   QRect rect;
   QString a;
   pText[text_index]->getCursorPosition(&line, &col);
   rect = pText[text_index]->geometry();
   len = ((rect.bottom() - rect.y() + 3) / 18) - 1;
 
       last_line = line;
       last_col = col;
      Fun_ToolTip_flag = false;
       while(Fun_ToolTip_flag == false)
       {
	   pText[text_index]->moveCursor(QTextEdit::MoveUp, false);
	   pText[text_index]->getCursorPosition(&line, &col);
	   if(line == 0)
	       break;
       }
       pText[text_index]->setCursorPosition(line + len, last_col);       
       pText[text_index]->setCursorPosition(last_line, last_col);      
       pFun_Label[text_index]->setText(Fun_name);
       a = pText[text_index]->text(last_line);
       strncat(temp, a.ascii(), last_col);
       for(int i = 0 ; i <strlen(temp) ; i++)
       {
	   if(temp[i] == ' ')
	   {
	      col_len = col_len + 4;
	      last_col--;
	   }
	   if(temp[i] == '	')
	   {
	     col_len = col_len + (4*14);
	     last_col--;	       
	   }
       }
       if( last_line == line+len )
       {
	   pFun_Label[text_index]->setGeometry(rect.x()+ ((last_col + 1) *7) + col_len -8, rect.y()-24+((last_line - line)*18 ), pFun_Label[text_index]->text().length()*8, 20 );   
       }
       else if(last_line == line+len +1)
       {
	pFun_Label[text_index]->setGeometry(rect.x()+ ((last_col + 1) *7) + col_len -8, rect.y()-34+((last_line - line)*18 ), pFun_Label[text_index]->text().length()*8, 20 );   
	   
       }
       else if(len < pText[text_index]->lines())
       {
	   pFun_Label[text_index]->setGeometry(rect.x()+ ((last_col + 1) *7) + col_len -8, rect.y()+4+((last_line - line +1)*18 ), pFun_Label[text_index]->text().length()*8, 20 );   
       }
       else
       {
	   pFun_Label[text_index]->setGeometry(rect.x()+ ((last_col + 1) *7) + col_len -8, rect.y()+4+((last_line - line +1)*18 ), pFun_Label[text_index]->text().length()*8, 20 );
       }
       pFun_Label[text_index]->show();
}




//find Conect Workspace menu
void MainForm::WorkSpace_R_Button_clicked()
{
    QPopupMenu *pop_menu = new QPopupMenu(this);
    QCursor cur;

    pop_menu->setFont(QFont("Sans Serif", 10, QFont::Normal));
    
    if(WorkSpace->currentItem() == ProItem)
    {
	if(ProItem->text(0) == "  NO Project")
	{
	    pop_menu->insertItem("&New Project", this,  SLOT(Open_Mk_ProForm()));
	    pop_menu->insertItem("&Open Project", this, SLOT(Open_Mk_ProForm()));
	}
	else
	{
	    pop_menu->insertItem("&New Project", this,  SLOT(Open_Main_Form()));
	    pop_menu->insertItem("&Open Project", this, SLOT(Open_Mk_ProForm()));
	}
	pop_menu->insertItem("&ADD File(Source File & HeaderFile)", this,  SLOT(fileNew()));
	pop_menu->insertItem("&Open File(Source File & HeaderFile)", this,  SLOT(fileOpen()));
    }
    else if(WorkSpace->currentItem() == HeadItem || WorkSpace->currentItem() == SourceItem)
    {
	pop_menu->insertItem("&ADD File(Source File & HeaderFile)", this,  SLOT(fileNew()));
	pop_menu->insertItem("&Open File(Source File & HeaderFile)", this,  SLOT(fileOpen()));

    }
    else if(WorkSpace->currentItem() == MakeItem)
    {
	return; 
    }
    else
    {
	pop_menu->insertItem("&ADD File(Source File & HeaderFile)", this,  SLOT(fileNew()));
	pop_menu->insertItem("&Open File(Source File & HeaderFile)", this,  SLOT(fileOpen()));
	pop_menu->insertItem("&Delete Selected File", this,  SLOT(Delete_Soure_Header_File()));
	pop_menu->insertItem("&Compile Only this file", this,  SLOT(compile_one_file()));
    }
    pop_menu->setGeometry(cur.pos().x(), cur.pos().y(), 100, 100);
    pop_menu->show();

}

// find Mk_ProFom
void MainForm::Open_Mk_ProForm()
{
    QString filename = QFileDialog::getOpenFileName(Path, "Source & Header (*.gp)",  this, "open Project ", "Choose a Project" );
    if(filename.isEmpty())
    {
	return ;
    }
    if( history_num < 5 )
    {
	ReWrite_History( 0 , filename, -1, "dd");    
    }
    else
    {
	ReWrite_History( 0 , filename, history_num -1, "dd");
    }
    Open_New_Project( filename );
}


void MainForm::Open_New_Project( QString filename )
{
    Check_Save();
    QListViewItem *item;
    bool flag = false;
    WorkSpace->setCurrentItem( ProItem );
    
   
    while(item != MakeItem)
    {
	if( flag == false)
	    WorkSpace->setCurrentItem(HeadItem);
	else
	    WorkSpace->setCurrentItem(SourceItem);
	item = WorkSpace->currentItem()->itemBelow();
	if( item == SourceItem)
	    flag = true;
	WorkSpace->setCurrentItem(item);
	if( item == ProItem || item == SourceItem || item == HeadItem || item == MakeItem )
	{
	}
	else
	{
	    Delete_Tab_Workspace();
	}
    }
    Inisialize_MainWidget();
    ProItem->setText( 0 , "  NO Project");

    char pro_path[500]; 
    memset(&pro_path, 0, sizeof(pro_path));
    b pro(this);
    Mk_ProForm *Mk_form = new Mk_ProForm(this);
    ProName = Mk_form->Device_FileName_Path( filename );
    strncpy( pro_path, filename, filename.length() - ProName.length());
    Path.sprintf("%s", pro_path);
    memset(&pro_path, 0, sizeof(pro_path));
    strcpy(pro_path, filename.ascii());
    pro.Load_Project(pro_path);
    delete Mk_form;
}

void MainForm::Delete_Tab_Workspace()
{
    QString a;
    int i;
    int del_index;
    if(WorkSpace->currentItem()->text(0) == Tab_Editor->label(0))//remain Tab_page is one 
    {
	pText[0]->clear();
	pText[0]->hide();
	pFun_Label[0]->hide();
	Tab_Editor->showPage(Tab_Editor->page(0));
	Tab_Editor->changeTab(Tab_Editor->currentPage(), "None");
	del_index = 0;
	
    }
    else 
    {
	for( i = 0 ; i < Text_index + 1 ; i++)
	{
	    if(WorkSpace->currentItem()->text(0) == Tab_Editor->label(i))	    
	    {
		Tab_Editor->removePage(Tab_Editor->page(i));
		del_index = i;
		break;
	    }
	}
    }
    
    Text_index--;
    delete WorkSpace->currentItem();
}	

void MainForm::Inisialize_MainWidget()
{
    compile_select = false;
    findAction_flag  = false;
    Function_label->hide();
    Fun_ToolTip_flag = false;
    List_Function->hide();
    List_Fun_name->hide();
    QPixmap pix("/G_Studio/images/miniproject.png");
    QFile file;
    QString filename;
    file.setName("/G_Studio/History/History_Project.txt");
    QTextStream stream(&file);
    pro_list_text->hide();
    
    for( int i = 0 ; i < history_num ; i++)
    {
	fileMenu->removeItem( i );
    }
    if(!file.open(IO_ReadOnly))
    {
    }
    else
    {
	pro_list_text->setText(stream.read());
	file.close();
	for( int i = pro_list_text->paragraphs()-2 ; i > -1 ; i-- )
	{
	    filename = pro_list_text->text(i).remove( " ", false);
	    fileMenu->insertItem( pix, filename , i ,  4);
	    switch( i )
	    {
	    case 0:
		fileMenu->connectItem(i, this, SLOT( OpenProjectAction()));
		break;
	    case 1:
		fileMenu->connectItem(i, this, SLOT( OpenProjectAction1()));
		break;
	    case 2:
		fileMenu->connectItem(i, this, SLOT( OpenProjectAction2()));
		break;
	    case 3:
		fileMenu->connectItem(i, this, SLOT( OpenProjectAction3()));
		break;
	    case 4:
		fileMenu->connectItem(i, this, SLOT( OpenProjectAction4()));
		break;
	    }
	}
	history_num = pro_list_text->paragraphs()-1 ;
    }
    index = 0;
/////////Get WorkSpace Tree Pointer( Project, HeaderFile, SourceFile, MakeFile) ///////////////
    SourceItem->setOpen(true);
    HeadItem->setOpen(true); 
 //   WorkSpace->setSorting(0, false);
/////////////////////////////////////////////////////////////////////////////////////
//////  TabCotrol Variables ////////////////////////////////////////
    E_enterCode->hide();//hide message Printf("Please Enter the Any KEY");
   text->hide();
    Error_List->hide();
    compile_prograss->hide();
    Error_List->setGeometry(Error_Groupbox->rect());
    Error_Num->setGeometry(Error_Groupbox->rect());

    for(int i = 0 ; i < 30 ; i++)
    {
	Text_flag[i] = 0;
	pText[i] = 0;
	pFun_Label[i] = 0;
    }
    pText[0] = text;
    pFun_Label[0] = Function_label;
    Text_index = 0;
//////////////////////////////////////////////////////////////

}
void MainForm::Delete_Soure_Header_File()
{
    QString a;
    int i;
    int delete_flag;
    int del_index;
    char path[300];
    char del_name[100];
    memset(&path, 0, sizeof(path));
    memset(&del_name, 0, sizeof(del_name));
    a.sprintf("%s%s", Path.ascii(), ProName.ascii());
    strcpy(path, a.ascii());
    strcpy(del_name, WorkSpace->currentItem()->text(0).ascii());
    b pro(this);
    
    if(WorkSpace->currentItem()->text(0).endsWith(".h"))
    {
	delete_flag = pro.del_Header_File( path , del_name); 
    }
    else if(WorkSpace->currentItem()->text(0).endsWith(".c"))
    {
	delete_flag = pro.del_Source_File( path , del_name);
    }

    if( delete_flag == 0 )
    {
	if(Text_index == 1)//remain Tab_page is one
	{
	    pText[0]->clear();
	    pText[0]->hide();
	    pFun_Label[0]->hide();
	    Tab_Editor->changeTab(Tab_Editor->currentPage(), "None");
	    del_index = 0;
	    
	}
	else 
	{
	    for( i = 0 ; i < Text_index ; i++)
	    {
		if(WorkSpace->currentItem()->text(0) == Tab_Editor->label(i))	    
		{
		    Tab_Editor->removePage(Tab_Editor->page(i));
		    del_index = i;
		    break;
		}
	    }
	}
	
	for( i = del_index ; i < Text_index - 1; i++)
	{
	    pText[i] = pText[i+1];
	    pFun_Label[i] = pFun_Label[i+1];
	} 
	Text_index--;
	if(Text_index != 0)
	{
	    pText[Text_index] = 0;
	    pFun_Label[Text_index] = 0;
	}
	switch (QMessageBox::question(this, "File Delete", "Do you want to delete File( "+ WorkSpace->currentItem()->text(0)+" )!!", QMessageBox::Yes, QMessageBox::No ))
	{
	 case 3:
	     system("rm " + Path + WorkSpace->currentItem()->text(0));
	     break;
	 case 4:
	     ;
	     break;
	 }
	 delete WorkSpace->currentItem();
    }
       
}



void MainForm::Clicked_DebuggingAction()
{
     if( ProItem->text(0) == "  NO Project")
    {
	QMessageBox::critical(this, "NO Project", "There is not Poject!!\nPlease load & create the Project file!!");
	return ;	
    }
    Auto_MakeFile();
    while( exe_proc->isRunning())
    {
	;
    }
    char sentence[300];
    memset(&sentence, 0, sizeof(sentence));
    QString exe_file;
    QDir dir(Path,QString::null, QDir::DirsFirst);
    dir.setMatchAllDirs(true);
    QStringList entries = dir.entryList();
    int len = strlen(ProName.ascii());
    strncat(sentence, ProName.ascii(), len-3); 
    if(entries.contains(sentence) < 1)
    {
	QMessageBox::critical(this, "Error", "Can not Enter the Debuger Form!!\nPlease solve the Code Error!!");
	return;	
    }
    Debuger_Form *debuger = new Debuger_Form(this);
    debuger->Set_MainForm_Pointer( this );
    debuger->Set_File_List();
    debuger->show();
}

void MainForm::destroy()
{
    Check_Save();
}




void MainForm::compile_one_file()
{
    compile_select = true;
    char sentence[300];
    memset(&sentence, 0, sizeof(sentence));
    QString filename = WorkSpace->currentItem()->text(0);
    if( filename.endsWith(".h") == true )
    {
	QMessageBox::critical(this, "Can not compile", "This is Headerfile!!So can not compile!!");
	return;	
    }
    strncat(sentence, filename, filename.length()-2);
    filename.sprintf("%s", sentence);
    fileSave();  //All file save before Compiling
    memset(&sentence, 0, sizeof(sentence));
    QStringList list;// List of c File
    QString pro_path;
    QString exe_file;
    int len = strlen(ProName.ascii());
    strncat(sentence, ProName.ascii(), len-3); 
    exe_file.sprintf("%s", sentence);
    char PATH[500];
    memset(&PATH, 0, sizeof(PATH));
    pro_path.sprintf("%s%s", Path.ascii(), ProName.ascii()); 
    strcpy(PATH, pro_path.ascii());
    b pro(this);
    list = pro.Set_CompileList(PATH);
    system("rm " + Path +exe_file);
    QString Compiler;//Compiler
    Compiler.sprintf("%s ", pro.G_pro.Compiler);    
    
    QStringList::ConstIterator it = list.constBegin();
    Project_Setting *pro_set = new Project_Setting(this);
    
    if(pro.Display_Project_Option(pro_set, PATH) == -1)
    {
	delete pro_set;
	return;
    }
    
    system("rm " + Path + exe_file);// Delete Excution File Befor Compile
    
              FILE *fp; 
	pro_path.sprintf("%s%s", Path.ascii(), "Makefile");
	fp = fopen(  pro_path.ascii() , "w"); 
	fprintf( fp, "all : %s\n\n", exe_file.ascii());
	fprintf( fp, "%s : ", exe_file.ascii());
	 
	while(it != list.constEnd())
	{
	    if( filename == *it)
	    {
		fprintf(fp, "%s.o ", (*it).ascii());
	    }
	    ++it;
	}
	
	fprintf(fp, "\n"); 
	it = list.constBegin();
	fprintf(fp, "\t%s%s%s ", Compiler.ascii(), pro_set->Make_Option_Line(0).ascii(), exe_file.ascii());
	
	while(it != list.constEnd())
	{
	    if( filename == *it)
	    {
	    	fprintf(fp, "%s.o ", (*it).ascii());
	    }
	    ++it;
	}
	fprintf(fp, "%s\n\n\n\n", pro_set->Make_Libaray_Line(0).ascii()); 
	it = list.constBegin();
	int i;
	QString temp;
	while(it != list.constEnd())
	{
	    if( filename == *it)
	    {
		for(i = 0 ; i < pro_set->Tab_Index ; i++)
		{
		    temp.sprintf("%s.c", (*it).ascii());
		    if(strcmp(temp.ascii(), pro_set->File_Tab->label(i).ascii()) == 0)
			break;
		}
		fprintf(fp, "%s.o : %s.c\n", (*it).ascii(), (*it).ascii());
		fprintf(fp, "\t%s%s%s.o %s.c %s\n\n", Compiler.ascii(), pro_set->Make_Option_Line(i).ascii(), (*it).ascii(), (*it).ascii(), pro_set->Make_Libaray_Line(i).ascii());
	    }
	    ++it;
	}
	delete pro_set;
	fclose(fp);
	fileSave();
	Error_Num->clear();
	Error_List->clear();
	G_Report_Form *g_report = new G_Report_Form(this);
	g_report->SetMainFormPointer(this);
	g_report->Make();    

}


bool MainForm::Function_FSA( QString Line_Code )
{
   bool FSA_flag = false;
    bool Function_flag = false;
    bool string_comment_flag = false;
    bool midle = false; // Check Token '  {  '
    bool small = false; // Check Token ' ( '
    char CodeLine[1000];
    char Token[100];
    int Token_index = 0;
    memset(&CodeLine, 0, sizeof(CodeLine));
    memset(&Token, 0, sizeof(Token));
    strcpy(CodeLine, Line_Code.ascii());
    
    for(int i = 0 ; i < strlen(CodeLine) ; i++) // Create Token Strem And Token Checking
    {
	
	if( CodeLine[i] == '"')
	{
	    if( string_comment_flag == false)
		string_comment_flag = true;
	    else
		string_comment_flag - false;
	}
	else if(CodeLine[i] == '/' && CodeLine[i+1] == '/'&& string_comment_flag == false)// if Sentance is Commnet '//'
	{
//	    QMessageBox::question(this, "Comment", CodeLine);
	    return false; 
	}
	else if(CodeLine[i] == '/' && CodeLine[i+1] == '*'&& string_comment_flag == false)// if Sentance is Commnet '/*'
	{
	   i =  Comment_Filter( i );
	   memset(&CodeLine, 0, sizeof(CodeLine));
	   strcpy(CodeLine, Line_Code.ascii());
	}
	else if( CodeLine[i] == ' ' || CodeLine[i] == '	' && string_comment_flag == false )
	{
	    memset(&Token, 0, sizeof(Token));
	    Token_index = 0;
	    //Checking Token && inisialize of Token
	}
	else if( CodeLine[i] == '(' && string_comment_flag == false )
	{
	    memset(&Token, 0, sizeof(Token));
	    Token_index = 0;
	    Function_flag = true;
	    //Checking Token && inisialize of Token
	    if( FSA_flag == false )
	    {
		FSA_flag = true;
		small = true;
	    }//End if( FSA_flag == false )
	}
	else if(CodeLine[i] == ')' && string_comment_flag == false)
	{
	    memset(&Token, 0, sizeof(Token));
	    Token_index = 0;
	    //Checking Token && inisialize of Token
	    if( FSA_flag == true )
	    {
		FSA_flag = false;
	    }//End if( FSA_flag == false )
	}
	else if(CodeLine[i] == ';' && string_comment_flag == false)
	{
	    return false;
	}
	else if(CodeLine[i] == '{' && string_comment_flag == false)
	{
	    memset(&Token, 0, sizeof(Token));
	    Token_index = 0;
	    if( FSA_flag == false && small == true && Function_flag == true )
	    {
		 midle = true;
		return true;
	    }
	}
	else
	{
	    if( string_comment_flag == false)
	    {
		Token[Token_index] = CodeLine[i];
		Token_index++;
	    }
	}

    }//End for(int i = 0 ; i < strlen(CodeLine) + 1 ; i++) : Lincode End
    
    if(midle == false )
    {
	while(1)
	{
	    memset(&CodeLine, 0, sizeof(CodeLine));
	    if(Line_index < pText[File_index]->paragraphs ()-1)
		strcpy(CodeLine, pText[File_index]->text(++Line_index).ascii());
	    else
		return false;
	    
	    for(int i = 0  ; i < strlen(CodeLine) ; i++)
	    {
		if(CodeLine[i] == ' ' || CodeLine[i] == '	')
		{
		    ;
		}
		else if(CodeLine[i] == '{')
		{ 
		    return true;
		}
		else
		{
		    --Line_index;
		    return false;
		}
	    }
	}
    }

}


bool MainForm::Find_main_Func()
{
   char Token[100];
    char CodeLine[1000];
    int token_index = 0;
    bool comment_flag = true;
    bool flag = false;
    bool main_flag = false;
    memset(&Token, 0, sizeof(Token));
  
    for( int i = 0 ; i < 100 ; i++)
    {
	memset(&CodeLine, 0, sizeof(CodeLine));  
	strcpy(CodeLine, pText[File_index]->text(Line_index - i).ascii());
	memset(&Token, 0, sizeof(Token));
	for( int j = 0 ; j < strlen(CodeLine) ; j++)
	{
	    if(CodeLine[j] == '/' && CodeLine[j+1] == '/')
	    {
		break;		
	    }
	    else if(CodeLine[j] == '/' && CodeLine[j+1] == '*')
	    {
		comment_flag = false;
	    }
	    else if(CodeLine[j] == '*' && CodeLine[j+1] == '/')
	    {
		comment_flag = true;
	    }
	    else if(CodeLine[j] == '{')
	    {
		break;
	    }
	    else if( CodeLine[j] == ' ' || CodeLine[j] == '	' || CodeLine[j] == '(' )
	    {
		if(strcmp( Token, "main") == 0)
		{
		    main_flag = true;
		    break;
		}
		memset(&Token, 0, sizeof(Token));
		token_index = 0;
	    
	    }
	    else if(comment_flag)
	    {
		flag = true;
		Token[token_index] = CodeLine[j];
		token_index++;
	    }
	}
	if( flag )
	    return main_flag;
    }
}



int MainForm::Comment_Filter( int num )
{
    char CodeLine[1000];
    memset(&CodeLine, 0, sizeof(CodeLine));
    strcpy(CodeLine, pText[File_index]->text(Line_index).ascii());
    while( 1 )
    {
	for( num ; num < strlen(CodeLine) ; num++)
	{
	    if(CodeLine[num] == '*' && CodeLine[num+1] == '/') 
	    {
		return num;
	    }
	}
	memset(&CodeLine, 0, sizeof(CodeLine));
	strcpy(CodeLine, pText[File_index]->text(++Line_index).ascii());
	num = 0;
    }
}


void MainForm::Func_End_FSA()
{
    int midle_flag = 1;
    char CodeLine[1000];
    char Token[100];
    int Token_index = 0;
    QString snprintf_code;
    QString main_code;
    QString temp;
    memset(&CodeLine, 0, sizeof(CodeLine));
    memset(&Token, 0, sizeof(Token));
    bool string_comment_flag = false;
    while(midle_flag != 0)
    {
	memset(&CodeLine, 0, sizeof(CodeLine));
	
	if( pText[File_index]->paragraphs ()-1 == Line_index )
	    return;
	else
	    strcpy(CodeLine, pText[File_index]->text(++Line_index).ascii());
	for( int i = 0 ; i < strlen(CodeLine)+1 ; i++)
	{
	    if( CodeLine[i] == '"')
	    {
		if( string_comment_flag == false)
		    string_comment_flag = true;
		else
		    string_comment_flag = false;
	    }
	    else if(CodeLine[i] == '/' && CodeLine[i+1] == '/'&& string_comment_flag == false)
	    {
		break;
	    }
	    else if(CodeLine[i] == '/' && CodeLine[i+1] == '*'&& string_comment_flag == false)
	    {
		i = Comment_Filter( i )+1;
		memset(&CodeLine, 0, sizeof(CodeLine));
		strcpy(CodeLine, pText[File_index]->text(Line_index).ascii());
	    }
	    else if( CodeLine[i] == ' ' || CodeLine[i] == '	' || CodeLine[i] == '(' || CodeLine[i] == ')' && string_comment_flag == false)
	    {
		if(strcmp( Token, "return") == 0)
		{
		    pText[File_index]->insertAt(E_enterCode->text(), Line_index, i-6);
		}
		
		memset(&Token, 0, sizeof(Token));
		Token_index = 0;
	    }
	    else if(CodeLine[i] == ';'&& string_comment_flag == false) 
	    {
		
		if(strcmp( Token, "return") == 0)
		{
    		    pText[File_index]->insertAt(E_enterCode->text(), Line_index, i-6);
		}
		
		memset(&Token, 0, sizeof(Token));
		Token_index = 0;
	    }
	    else if(CodeLine[i] == '{'&& string_comment_flag == false)
	    {
		memset(&Token, 0, sizeof(Token));
		Token_index = 0;
		midle_flag++;
	    }
	    else if(CodeLine[i] == '}'&& string_comment_flag == false)
	    {
		memset(&Token, 0, sizeof(Token));
		Token_index = 0;
		midle_flag--;
	    }	    
	    else if(string_comment_flag == false)
	    {
		Token[Token_index] = CodeLine[i];
		Token_index++;
	    }
	}

    }
}




void MainForm::Exit_Main()
{
    this->close();
}


void MainForm::HelpActionclicked()
{

}
