/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qbuttongroup.h>
#include <qmessagebox.h> 
#include <qtextcodec.h> 
#include <qradiobutton.h>
#include <qwidget.h>
#include <qtextedit.h> 
#include <qrect.h> 
#include <qfile.h> 
#include <qfont.h>  
#include <qfiledialog.h>
#include <qtextstream.h> 
#include <qlistview.h>  
#include "NewFileForm.h"
#include "Mk_ProForm.h"
#include "G_Report_Form.h" 
#include "MainForm.h"
#include "Option_Form.h"
#include <string.h>
#include <stdio.h>
#include <qlistbox.h>
#include <qregexp.h>
#include <qvalidator.h>
#include <qstringlist.h>
void Project_Setting::init()
{
   QRegExp regExp("[A-Za-z] [1-9] [0-9] {0, 2}");
   E_File_Name->setValidator(new QRegExpValidator(regExp, this)); 
   E_Library->setValidator(new QRegExpValidator(regExp, this));
   E_Option->setValidator(new QRegExpValidator(regExp, this));
   Tab_Index = 0;
   flag = false;
   pOption[Tab_Index] = Option_List;
   pLibaray[Tab_Index] = Library_List;   
}

bool Project_Setting::Display_File_Option( char option[1000], char file_name[100] )
{
    QString name;
    QWidget *pTabPage = NULL;
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
    name.sprintf("%s", option);
    if(File_Tab->label(0) == "None")// if the SourceFile is added at first..( TabPage is added at first)
    {

	File_Tab->changeTab(File_Tab->currentPage(), file_name); // Change TabPage Label( Source File name )
	pOption[Tab_Index]->insertItem("ADD Option", -1);
	pLibaray[Tab_Index]->insertItem("ADD Libaray", -1);
	Tab_Index++;
	
     }
    else
    {
	pTabPage = new QWidget(this->File_Tab); // Creat new Widget of TabPage
	pOption[Tab_Index] = new QListBox(pTabPage); // Store the Pointer of  TextEdit
	pLibaray[Tab_Index] = new QListBox(pTabPage);
	this->File_Tab->addTab(pTabPage, file_name);
	pOption[Tab_Index]->setGeometry(Option_List->geometry());
	pLibaray[Tab_Index]->setGeometry(Library_List->geometry());
	pOption[Tab_Index]->insertItem("ADD Option", -1);
	pLibaray[Tab_Index]->insertItem("ADD Libaray", -1);
	connect(pOption[Tab_Index], SIGNAL(doubleClicked(QListBoxItem*)), this, SLOT(Option_Box_DBClicked()));
	connect(pLibaray[Tab_Index], SIGNAL(doubleClicked(QListBoxItem*)), this, SLOT(Library_Box_DBClicked()));
	Tab_Index++;
    }
    
    int index = 0;
    int num = 0;
    char temp[100];
    memset(&temp, 0, sizeof(temp));
    for(int i = 0 ;  i < strlen(option) ; i++)
    {
	switch(index)
	{
	case 0:
	    if(option[i] == ' ' && option[i+1] == '-' )
	    {
		strncpy(temp, option + (i -num), num);
		name.sprintf("%s", temp);
		pOption[Tab_Index-1]->insertItem(name, -1);
		num = -1;
		memset(&temp, 0, sizeof(temp));
	    }
	   else if(option[i-1] == ' ' && option[i]  == '/')
	   {
	       strncpy(temp, option + (i -num), num);
	       name.sprintf("%s", temp);
	       pOption[Tab_Index-1]->insertItem(name, -1);
	       index = 1;
	       num = -1;
	       memset(&temp, 0, sizeof(temp));
	   }
	   break;
	case 1: 
	    if(option[i] == ' ')
	    {
		strncpy(temp, option + (i -num), num);
		name.sprintf("%s", temp);
		pLibaray[Tab_Index-1]->insertItem(name, -1);
		num = -1;
		memset(&temp, 0, sizeof(temp));
	    }
	    break;
	}//End switch case
	num++;
    }//End for(int i = 0 ;......................)
    
    if(flag == false)
    {
	E_Option->setText(Make_Option_Line(0));
	E_Library->setText(Make_Libaray_Line(0));
	flag = true;
    }
    return true;

}


void Project_Setting::SetMainFormPointer( MainForm * fp )
{
    mainform = fp;
}

QString Project_Setting::Make_Option_Line( int index )
{
    QString Option_Line;
    char temp[1000];
    memset(&temp, 0, sizeof(temp));
    for(int i = 1 ; i < pOption[index]->count() ; i++)
    {
	strcat(temp, pOption[index]->text(i).ascii());
	strcat(temp, " ");
    }
    Option_Line.sprintf("%s", temp);
    return Option_Line;
}


QString Project_Setting::Make_Libaray_Line( int index )
{
    QString Libaray_Line;
    char temp[1000];
    memset(&temp, 0, sizeof(temp));
    for(int i = 1 ; i < pLibaray[index]->count() ; i++)
    {
	strcat(temp, pLibaray[index]->text(i).ascii());
	strcat(temp, " ");
    }
    Libaray_Line.sprintf("%s", temp);
    return Libaray_Line;

}


void Project_Setting::Option_Box_DBClicked()
{
    
    if(pOption[File_Tab->indexOf(File_Tab->currentPage())]->currentText() == "ADD Option")
    {
	Option_Form *option_form = new Option_Form(this);
	option_form->Set_Pro_Set_Pointer(this);
	for(int i = 1 ; i < pOption[File_Tab->indexOf(File_Tab->currentPage())]->count() ; i++)
	    option_form->Add_Option_List(pOption[File_Tab->indexOf(File_Tab->currentPage())]->text(i));

	option_form->Option_collection->show();
	option_form->Library_collection->hide();	
	option_form->setModal(true);	
	option_form->show();
    }
}


void Project_Setting::Library_Box_DBClicked()
{

    if(pLibaray[File_Tab->indexOf(File_Tab->currentPage())]->currentText() == "ADD Libaray")
    {
	Option_Form *option_form = new Option_Form(this);
	option_form->Set_Pro_Set_Pointer(this);
	for(int i = 1 ; i < pLibaray[File_Tab->indexOf(File_Tab->currentPage())]->count() ; i++)
	    option_form->Add_Option_List(pLibaray[File_Tab->indexOf(File_Tab->currentPage())]->text(i));	
	option_form->Option_collection->hide();
	option_form->Library_collection->show();	
	option_form->setModal(true);
	option_form->show();
    }
}


void Project_Setting::File_Tab_chaged()
{
    E_Library->setText(Make_Libaray_Line(File_Tab->indexOf(File_Tab->currentPage())));
    E_Option->setText(Make_Option_Line(File_Tab->indexOf(File_Tab->currentPage())));
    E_File_Name->setText(File_Tab->tabLabel(File_Tab->currentPage()));
}


void Project_Setting::Rewrite_Option( QString option )
{
    pOption[File_Tab->indexOf(File_Tab->currentPage())]->insertItem(option, -1);
}


void Project_Setting::Rewrite_Library( QString library )
{
     pLibaray[File_Tab->indexOf(File_Tab->currentPage())]->insertItem(library, -1);
}


void Project_Setting::Option_List_Clear_currentPage()
{
    pOption[File_Tab->indexOf(File_Tab->currentPage())]->clear();
}


void Project_Setting::Library_List_Clear_currentPage()
{
     pLibaray[File_Tab->indexOf(File_Tab->currentPage())]->clear();
}


void Project_Setting::cmd_OK_button_clicked()
{
    QString temp;
    QStringList list;
    for(int i = 0 ; i < Tab_Index ; i++)
    {
	temp.sprintf("%s/%s", Make_Option_Line(i).ascii(), Make_Libaray_Line(i).ascii());
	list << temp;
    }
     if(mainform->Rewrite_Project_Option(list) == false)
    {
	QMessageBox::critical(this, "Option Save Error", "Can not save Option in Project");
	return ;
    }
    this->close();
}
