#include <stdio.h>
#include <string.h>
#include <iostream>
#include <qstring.h>
#include <qstringlist.h>
#include "MainForm.h"
#include "Mk_ProForm.h"
#include "NewFileForm.h"
#include "Project_Setting.h"
#include <qlistview.h>
#include <qmessagebox.h>


//ҽ ü
typedef struct File_name
{
	int File_node;
	char com_option[1000];
	char name[100];
}File_name;

//Ʈ ü
typedef struct Project
{
	char Pro_name[100];
	char Compiler[50];
	char Pro_option[1000];
	File_name Source;
	File_name Header;
	
}Project;

//Ʈ  Ŭ

class a
{
public:
	File_name F_name;
	Project G_pro;
	MainForm *pMainform;

public:
	a();
	a(MainForm *fp);
	~a();
	int Creat_Project(char path[300], char name[100], char compiler[50]);
	int Load_Project(char fileName[500]);
	int Display_Pro_infomation(char path[300]);
	int Add_Source_File(char name[100], char path[300]);
	int Add_Header_File(char name[100], char path[300]);
	int del_Source_File(char path[300] , char del_name[100]);
	int del_Header_File(char path[300] , char del_name[100]);
	QStringList Set_CompileList(char fileName[500]);
	int Display_Project_Option(Project_Setting *pro_set, char Path[300]);
	int Rewrite_Project_Option(QStringList list, char Path[300]);
};

a::a(MainForm *fp)
{
	memset(&F_name, 0, sizeof(File_name));
	memset(&G_pro, 0, sizeof(Project));
	G_pro.Source.File_node = -1;
	G_pro.Header.File_node = -1;
	pMainform = fp;

}

a::~a()
{
}

int a::Creat_Project(char path[300], char name[100], char compiler[50]) // , Ʈ , Ϸ 
{//Ʈ ó  θ Լ
	FILE *fp;
	QString pro_name;
	strcat(name,".gp");
	strcpy(G_pro.Pro_name, name);
	strcpy(G_pro.Compiler, compiler);
	strcat(G_pro.Pro_option, "-W -Wall -o /");		
	strcat(path, name);
	printf("%s", path);
	if((fp = fopen(path, "wb")) == NULL)
	{
		QMessageBox::critical(pMainform, "File Creat Error", "Can not Creat File!!\nIf your project path is HanGul, You must to select english path again!!");
		return -1;
	}
	fwrite(&G_pro, 1, sizeof(Project), fp);
	fclose(fp);
	pro_name.sprintf("  Project\n  %s", name);
	pMainform->ProItem->setText(0,pro_name);
	return 0;

}

int a::Load_Project(char fileName[500])
{//̹  Ʈ εҽ

	FILE *fp;
	
	File_name temp;

	QString PageName;

	if( (fp = fopen(fileName, "rb")) == NULL)
	{
		QMessageBox::critical(pMainform, "File Creat Error", "Can not Lode File!!\nIf your project path is HanGul, You must to select english path again!!");
		return -1;
	}

	fread(&G_pro, 1, sizeof(Project), fp);

	temp = G_pro.Source;

	PageName.sprintf("%s", temp.name);
	if(strlen(temp.name) != 0)
	QMessageBox::question(pMainform, "aa", PageName);
	QListViewItem *item; 
	PageName.sprintf("  Project\n  %s", G_pro.Pro_name);
	pMainform->ProItem->setText(0, PageName);
	if(strlen(temp.name) != 0)
	{
		item = pMainform->send_Source_Item_Pix(PageName.sprintf("%s", temp.name));		
		pMainform->SourceItem->insertItem(item);
		pMainform->Add_TabPage(PageName.sprintf("%s", temp.name));
		while(1)
		{
			if( temp.File_node > 0 )
			{
				fseek(fp, temp.File_node, SEEK_SET);			
				fread(&temp, 1, sizeof(File_name), fp);
				item = pMainform->send_Source_Item_Pix(PageName.sprintf("%s", temp.name));
				pMainform->SourceItem->insertItem(item);
				pMainform->Add_TabPage(PageName.sprintf("%s", temp.name));			
			}
			else
			{
				break;
			}
		}
	}


	temp = G_pro.Header;
	if(strlen(temp.name) != 0)
	{
		item = pMainform->send_Header_Item_Pix(PageName.sprintf("%s", temp.name));
		pMainform->HeadItem->insertItem(item);
		pMainform->Add_TabPage(PageName.sprintf("%s", temp.name));
		while(1)
		{
			if(temp.File_node > 0)
			{
				fseek(fp, temp.File_node, SEEK_SET);			
				fread(&temp, 1, sizeof(File_name), fp);
				item = pMainform->send_Header_Item_Pix(PageName.sprintf("%s", temp.name));
				pMainform->HeadItem->insertItem(item);
				pMainform->Add_TabPage(PageName.sprintf("%s", temp.name));
			}
			else
			{
				break;
			}
		}
	}
	

	fclose(fp);
	
	return 0;
}

int a::Add_Source_File(char name[100], char path[300])
{
	QString a;
	FILE *fp;
	int position;
	File_name temp;
	File_name add_file;
	memset(&temp, 0, sizeof(File_name));	
	memset(&add_file, 0, sizeof(File_name));
	strcpy(add_file.name, name);
	add_file.File_node = -1;
	strcpy(add_file.com_option, "-W -Wall -c -o /");
	if( (fp = fopen(path , "rb+")) == NULL)
	{
		QMessageBox::critical(pMainform, "File Add Error", "Can not Add File!!\nIf your project path is HanGul, You must to select english path again!!");
		return -1;
	}
	rewind(fp);
	fread(&G_pro, 1, sizeof(Project), fp);
	fseek(fp, 0L, SEEK_END);
	position = ftell(fp);
	a.sprintf("%s", name);
	QListViewItem *item = pMainform->send_Source_Item_Pix(a);
	if(strlen(G_pro.Source.name) == 0)
	{
		rewind(fp);
		strcpy(G_pro.Source.name, name);
		strcpy(G_pro.Source.com_option, "-W -Wall -c -o /");
		fwrite(&G_pro, 1, sizeof(Project), fp);
		pMainform->SourceItem->insertItem(item ); 
	}
	else if(G_pro.Source.File_node < 0)
	{
		fwrite(&add_file, 1, sizeof(File_name), fp);
		rewind(fp);
		G_pro.Source.File_node = position;
		fwrite(&G_pro, 1, sizeof(Project), fp);
		pMainform->SourceItem->insertItem(item); 

	}
	else
	{
		fwrite(&add_file, 1, sizeof(File_name), fp);
		temp = G_pro.Source;
		int temp_position;
		while(1)
		{
			temp_position = temp.File_node;
			fseek(fp, temp.File_node, SEEK_SET);
			fread(&temp, 1, sizeof(File_name), fp);
			if(temp.File_node < 0)
			{
				temp.File_node = position;
				fseek(fp, temp_position, SEEK_SET);
				fwrite(&temp, 1, sizeof(File_name), fp);
				pMainform->SourceItem->insertItem(item); 
				break;
			}
		}
	}
	fclose(fp);
	return 0;

}
int a::Add_Header_File(char name[100], char path[300])
{
	QString a;
	FILE *fp;
	int position;
	File_name temp;
	File_name add_file;
	strcpy(add_file.name, name);
	add_file.File_node = -1;
	if( (fp = fopen(path , "rb+")) == NULL)
	{
		QMessageBox::critical(pMainform, "File Add Error", "Can not Add File!!\nIf your project path is HanGul, You must to select english path again!!");
		return -1;
	}
	rewind(fp);
	fread(&G_pro, 1, sizeof(Project), fp);
	fseek(fp, 0L, SEEK_END);
	position = ftell(fp);
	a.sprintf("%s", name);
	QListViewItem *item = pMainform->send_Header_Item_Pix(a);
	if(strlen(G_pro.Header.name) == 0)
	{
		rewind(fp);
		strcpy(G_pro.Header.name, name);
		fwrite(&G_pro, 1, sizeof(Project), fp);
		pMainform->HeadItem->insertItem(item); 
	}
	else if(G_pro.Header.File_node < 0)
	{
		fwrite(&add_file, 1, sizeof(File_name), fp);
		rewind(fp);
		G_pro.Header.File_node = position;
		fwrite(&G_pro, 1, sizeof(Project), fp);
		pMainform->HeadItem->insertItem(item); 
	}
	else
	{
		fwrite(&add_file, 1, sizeof(File_name), fp);
		temp = G_pro.Header;
		int temp_position;
		while(1)
		{
			temp_position = temp.File_node;
			fseek(fp, temp.File_node, SEEK_SET);
			fread(&temp, 1, sizeof(File_name), fp);
			if(temp.File_node < 0)
			{
				temp.File_node = position;
				fseek(fp, temp_position, SEEK_SET);
				fwrite(&temp, 1, sizeof(File_name), fp);
				pMainform->HeadItem->insertItem(item); 
				break;
			}
		}
	}
	fclose(fp);
	return 0;
}

int a::Display_Pro_infomation(char path[300])
{
	FILE *fp;
	if( (fp = fopen(path , "rb+")) == NULL)
	{
		return -1;
	}
	fread(&G_pro, 1, sizeof(Project), fp);
	fclose(fp);
}

int a::del_Source_File(char path[300] , char del_name[100])
{
	FILE *fp;
	File_name temp;
	File_name after_temp;
	int pre_position;
	if( (fp = fopen( path, "rb+")) == NULL) 
	{
		QMessageBox::critical(pMainform, "File Delete Failed", "Please Retry");
		return -1;
	}

	fread(&G_pro, 1, sizeof(Project), fp);
	temp = G_pro.Source;
	if(strcmp(temp.name, del_name) == 0 && temp.File_node < 0)
	{
		memset(&G_pro.Source, 0, sizeof(File_name));
		rewind(fp);
		G_pro.Source.File_node = -1;
		fwrite(&G_pro, 1, sizeof(Project), fp);
	}
	else if(strcmp(temp.name, del_name) == 0)
	{
		fseek(fp, temp.File_node, SEEK_SET);
		fread(&temp, 1, sizeof(File_name), fp);
		memset(&G_pro.Source, 0, sizeof(File_name));
		G_pro.Source = temp;
		rewind(fp);
		fwrite(&G_pro, 1, sizeof(Project), fp);
	}
	else
	{
		fseek(fp, temp.File_node, SEEK_SET);			
		fread(&temp, 1, sizeof(File_name), fp);
		if(strcmp(temp.name, del_name) == 0)
		{
			G_pro.Source.File_node = temp.File_node;
			rewind(fp);
			fwrite(&G_pro, 1, sizeof(Project), fp);		
		}
		else
		{
			pre_position = G_pro.Source.File_node;

			while(1)
			{
				fseek(fp, temp.File_node, SEEK_SET);			
				fread(&after_temp, 1, sizeof(File_name), fp);
	
				if( strcmp(after_temp.name, del_name) == 0)
				{
					temp.File_node = after_temp.File_node;
					fseek(fp, pre_position , SEEK_SET);			
					fwrite(&temp, 1, sizeof(File_name), fp);
					break;
				}
				else
				{
					pre_position = temp.File_node;
					temp = after_temp;
				}
				if(after_temp.File_node < 0)
					return -1;
			}
		}//End of if(strcmp(temp.name, del_name) == 0)



	}
	fclose(fp);
	return 0;

}

int a::del_Header_File(char path[300] , char del_name[100])
{

	FILE *fp;
	File_name temp;
	File_name after_temp;
	int pre_position;
	if( (fp = fopen( path, "rb+")) == NULL) 
	{
		QMessageBox::critical(pMainform, "File Delete Failed", "Please Retry");
		return -1;
	}

	fread(&G_pro, 1, sizeof(Project), fp);
	temp = G_pro.Header;
	if(strcmp(temp.name, del_name) == 0 && temp.File_node < 0)
	{
		memset(&G_pro.Header, 0, sizeof(File_name));
		rewind(fp);
		G_pro.Header.File_node = -1;
		fwrite(&G_pro, 1, sizeof(Project), fp);
	}
	else if(strcmp(temp.name, del_name) == 0)
	{
		fseek(fp, temp.File_node, SEEK_SET);
		fread(&temp, 1, sizeof(File_name), fp);
		memset(&G_pro.Header, 0, sizeof(File_name));
		G_pro.Header = temp;
		rewind(fp);
		fwrite(&G_pro, 1, sizeof(Project), fp);
	}
	else
	{
		fseek(fp, temp.File_node, SEEK_SET);			
		fread(&temp, 1, sizeof(File_name), fp);
		if(strcmp(temp.name, del_name) == 0)
		{
			G_pro.Header.File_node = temp.File_node;
			rewind(fp);
			fwrite(&G_pro, 1, sizeof(Project), fp);		
		}
		else
		{
			pre_position = G_pro.Header.File_node;

			while(1)
			{
				fseek(fp, temp.File_node, SEEK_SET);			
				fread(&after_temp, 1, sizeof(File_name), fp);
	
				if( strcmp(after_temp.name, del_name) == 0)
				{
					temp.File_node = after_temp.File_node;
					fseek(fp, pre_position , SEEK_SET);			
					fwrite(&temp, 1, sizeof(File_name), fp);
					break;
				}
				else
				{
					pre_position = temp.File_node;
					temp = after_temp;
				}
				if(after_temp.File_node < 0)
					return -1;
			}
		}//End of if(strcmp(temp.name, del_name) == 0)



	}
	fclose(fp);
	return 0;


}

QStringList a::Set_CompileList(char fileName[500])
{
	FILE *fp;
	File_name temp;
	char name[100];
	int len;
	int i;
	QStringList list;
	if((fp = fopen(fileName, "rb")) == NULL)
	{
		
		return list;
	}
	fread(&G_pro, 1, sizeof(Project), fp);
	temp = G_pro.Source;
	if(strlen(temp.name) != 0)
	{
		len = strlen(temp.name);
		memset(&name, 0, sizeof(name));
		for( i = len - 1 ; i > -1 ; i--)
		{
			if(temp.name[i] == '.')
			{
				strncat(name, temp.name, i);
				list << name;
				break;
			}
		}			

		while(1)
		{
			if( temp.File_node > 0 )
			{
				fseek(fp, temp.File_node, SEEK_SET);			
				fread(&temp, 1, sizeof(File_name), fp);
				len = strlen(temp.name);
				memset(&name, 0, sizeof(name));
				for( i = len - 1 ; i > -1 ; i--)
				{
					if(temp.name[i] == '.')
					{
						strncat(name, temp.name, i);
						list << name;
						break;
					}
				}
				
			}
			else
			{
				break;
			}
		}
	}

	fclose(fp);
	
	return list;

}
int a::Display_Project_Option(Project_Setting *pro_set, char Path[300])
{
	FILE *fp;
	File_name temp;
	int i;
	if((fp = fopen(Path, "rb")) == NULL)
	{
		return -1;
	}
	fread(&G_pro, 1, sizeof(Project), fp);

	pro_set->Display_File_Option(G_pro.Pro_option, G_pro.Pro_name);

	temp = G_pro.Source;
	if(strlen(temp.name) != 0)
	{
		pro_set->Display_File_Option(temp.com_option, temp.name);
		while(1)
		{
			if( temp.File_node > 0 )
			{
				fseek(fp, temp.File_node, SEEK_SET);			
				fread(&temp, 1, sizeof(File_name), fp);
				pro_set->Display_File_Option(temp.com_option, temp.name);				
			}
			else
			{
				break;
			}
		}
	}
	fclose(fp);
	return 0;
	
}
int a::Rewrite_Project_Option(QStringList list, char Path[300])
{
	QStringList::ConstIterator it = list.constBegin();
	FILE *fp;
	File_name temp;
	int i;
	int pre_position;
	if((fp = fopen(Path, "rb+")) == NULL)
	{
		return -1;
	}
	rewind(fp);
	fread(&G_pro, 1, sizeof(Project), fp);
	strcpy(G_pro.Pro_option, (*it).ascii());
	it++;
	rewind(fp);
	fwrite(&G_pro, 1, sizeof(Project), fp);	
	temp = G_pro.Source;
	if(strlen(temp.name) != 0)
	{
		strcpy(G_pro.Source.com_option, (*it).ascii());
		it++;
		rewind(fp);
		fwrite(&G_pro, 1, sizeof(Project), fp);
		while(1)
		{
			if( temp.File_node > 0 )
			{
				pre_position = temp.File_node;
				fseek(fp, temp.File_node, SEEK_SET);			
				fread(&temp, 1, sizeof(File_name), fp);
				strcpy(temp.com_option, (*it).ascii());
				fseek(fp, pre_position, SEEK_SET);
				fwrite(&temp, 1, sizeof(File_name), fp);
				it++;				
			}
			else
			{
				break;
			}
		}
	}
	fclose(fp);	
	return 0;

}
